/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:40 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:40 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      expassociation.cpp                      */
/************************************************/

#include "expassociation.h"
#include "expinclude.h"
#include <noyclasse.h>
#include <noycommun.h>
#include <expobjetfichier.h>
#include <expclasse.h>
#include <noyrelation.h>
#include <noyheritage.h>
#include <noyassociation.h>
#include <noyutilisation.h>
#include <noyagregation.h>
#include <exprelation.h>
#include <expdefine.h>
#include <expattribut.h>

ExpAssociation::ExpAssociation(Association * a, ExpClasse *c, ExpExport * racine):ExpRelation(a,c,racine) {
  if (_type) {
    traiterSource(c , a , racine);
  } else {
    traiterDestination( c , a , racine);
  }
}



void ExpAssociation::traiterSource(ExpClasse * c, Relation * r, ExpExport * racine){
  string nom = "";
  string type = "";
  int typeMultiplicite;
  string multiplicite = "";
  ExpClasse * dest = getClasseDest(c,r,racine);
  if (dest!=NULL) {
    if( isNumber(r->getMultipliciteDestination())
       || isIdentifier((r->getMultipliciteDestination()))){

      typeMultiplicite = MULT_ASSOC;
      if(isIdentifier((r->getMultipliciteDestination()))) {
	nom += r->getMultipliciteDestination();
      } else {
	nom += dest->Minuscules(dest->getNom()); 
	if(isNumber(r->getMultipliciteDestination()) && (r->getMultipliciteDestination())!="1") {
	  multiplicite = r->getMultipliciteDestination();
	  typeMultiplicite = MULT_ASSOC_INT;
	}
      }
      ExpAttribut attribut(dest->getNom(),nom,typeMultiplicite,multiplicite);
      c->ajouterAttribut(attribut);
      c->ajouterInclude(c,dest,false,INC_OBLIGATOIRE);
    } else {
      if((r->getMultipliciteDestination())!="0" && (r->getMultipliciteDestination())!=""  ) { 
	nom += dest->Minuscules(dest->getNom()); 
	type += dest->getNom();
	ExpAttribut attribut(type,nom,MULT_ASSOC_MULT);
	c->ajouterAttribut(attribut);
	c->ajouterInclude(c,dest,false,INC_OBLIGATOIRE);
	c->ajouterInclude(c,dest,false,INC_VECTEUR);      
      }
    }
  }
}

void ExpAssociation::traiterDestination(ExpClasse * c, Relation * r, ExpExport * racine){
  string nom = "";
  string type = "";
  int typeMultiplicite; 
  string multiplicite = "";
  ExpClasse * dest = getClasseDest(c,r,racine);
  if (r->getDoubleFleche()){
    if (dest!=NULL) {
      if( isNumber(r->getMultipliciteSource())
	 || isIdentifier((r->getMultipliciteSource()))){
	

	typeMultiplicite = MULT_ASSOC;
	if(isIdentifier((r->getMultipliciteSource()))) {
	  nom += r->getMultipliciteSource();
	} else {
	  nom += dest->Minuscules(dest->getNom()); 
	  if(isNumber(r->getMultipliciteSource()) && (r->getMultipliciteSource())!="1") {
	    multiplicite = r->getMultipliciteSource();
	    typeMultiplicite = MULT_ASSOC;
	  }
	}
	ExpAttribut attribut(dest->getNom(),nom,typeMultiplicite,multiplicite);
	c->ajouterAttribut(attribut);
	c->ajouterInclude(c,dest,false,INC_OBLIGATOIRE);
      } else {
	if((r->getMultipliciteSource())!="0" && (r->getMultipliciteSource())!="") { 
	  nom += dest->Minuscules(dest->getNom()); 
	  type += dest->getNom();
	  ExpAttribut attribut(type,nom,MULT_ASSOC_MULT);
	  c->ajouterAttribut(attribut);
	  c->ajouterInclude(c,dest,false,INC_OBLIGATOIRE);
	  c->ajouterInclude(c,dest,false,INC_VECTEUR);      
	}
      }
    }
  }
}



