/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:45 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:45 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      expparametre.h                            */
/************************************************/

#ifndef EXPPARAMETRE_H
#define EXPPARAMETRE_H

#include <string>
#ifndef NOYPARAMETRE_H
class Parametre;
#endif
/**
 * Classe reprsentant un paramtre d'une mthode
 * @author A.Pique
 */

class ExpParametre {

 private:
  //! Type du paramtre
  string _type;
  //! Nom du paramtre
  string _nom;
  
 public:
  /**
   *Constructeur
   * \param Parametre *parametre : instance de classe Parametre d'o l'on rcupre
   * les informations pour initialiser l'instance de cet objet
   */
  ExpParametre ( Parametre *parametre );
  //! Destructeur
  ~ExpParametre ( );
  /**
   * Modificateur de l'attribut _type
   * \param string type : nouvelle valeur de type
   */
  void setType ( string type );
  /** Accesseur de _type
   * \return Le type
   */
  string getType (  );
  /**
   * Modificateur de l'attribut _nom
   * \param string nom : nouvelle valeur de nom
   */
  void setNom ( string nom );
  /** Accesseur de _nom
   * \return Le nom
   */
  string getNom (  );
};

#endif
