/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:45 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:45 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      exprelation.cpp                         */
/************************************************/
#include <expdefine.h>
#include "exprelation.h"
#include <noyclasse.h>
#include <noycommun.h>
#include <noyrelation.h>
#include <noyheritage.h>
#include <noyassociation.h>
#include <noyutilisation.h>
#include <noyagregation.h>
#include <expexport.h>
#include <expclasse.h>

ExpRelation::ExpRelation() {}
ExpRelation::ExpRelation(Relation * r, ExpClasse *c, ExpExport * racine){
  if((r->getClasseSource())==(c->getClasse())) {
    _type = true;
  } else {
    if((r->getClasseDestination())==(c->getClasse()))
      _type = false;
  }
}


ExpClasse * ExpRelation::getClasseDest(ExpClasse * c, Relation * r, ExpExport * racine){
  string s = "";
  string subS ;
  string::size_type pos = 0;
  string::size_type posAnc = 0;
  ExpObjetFichier * o = racine;
  ExpClasse * expDest = NULL;
  Classe * dest = r->getClasseDestination();
  if (dest!=NULL) {
    if (dest == (c->getClasse())) {
      dest = r->getClasseSource();
    }
    if (dest!=NULL) {
      s = dest->getNomComplet();
      pos = s.find("::",posAnc);
      while(posAnc!=string::npos && (o != NULL)) {
	subS = s.substr(posAnc,pos-posAnc);
	if (o->getPaquetage(subS)!=NULL){
	  o = (ExpObjetFichier *) o->getPaquetage(subS);
	} else {
	  expDest = o->getClasse(dest->getNom());
	  o = NULL;
	}
	posAnc=pos+2;
	pos = s.find("::",posAnc);
      }
      if (o!=NULL) 
	expDest = o->getClasse(dest->getNom());
      return expDest;
    } else {
      return NULL;
    }
  } else {
    return NULL;
  }
}


bool ExpRelation::isIdentifier ( string chaine ) 
{
  string::size_type pos = 0;
  bool bon_caractere ;  

  if(chaine == "")
    return false;
  
  bon_caractere  =  isAlpha(chaine.substr(pos,1)) || chaine.substr(pos,1) == "_" ;
  if ( ! bon_caractere )
    return false ; 
  
  ++pos ;
  while ( pos != chaine.length() ) {
    bon_caractere  = isAlpha(chaine.substr(pos,1))
      || isDigit(chaine.substr(pos,1))
      || chaine.substr(pos,1) == "_"
      || chaine.substr(pos,1) == "" ;

    if ( ! bon_caractere )
      return false ;
    
    ++pos ;
  }
  
  return true ;
}


bool ExpRelation::isNumber ( string chaine ) 
{
  string::size_type pos = 0;
  bool bon_nombre ;  


  if (chaine == "0" || chaine == "")
    return false ; 
  
  while ( pos != chaine.length() ) {
    bon_nombre  = isDigit(chaine.substr(pos,1))
      || chaine.substr(pos,1) == "" ;

    if ( ! bon_nombre )
      return false ;
    
    ++pos ;
  }
  return true ;
}



bool ExpRelation::isAlpha(string s) {
  if( ("a"<=s && s<="z") || ("A"<=s && s<="Z") ) {
    return true;
  } else {
    return false;
  }
}

bool ExpRelation::isDigit(string s) {
  if("0"<=s && s<="9") {
    return true;
  } else {
    return false;
  }
}
