#include <qwidget.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qgroupbox.h>
#include <qmultilineedit.h> 
#include <qmessagebox.h>

#include <ihmeditercode.h>

EditerCode::EditerCode(FenetrePrincipale * fen, Methode * m,
	QWidget *parent, const char *name) : QWidget(parent,name)
{
	fenetre = fen;
/*	std::vector<Methode *> vctMethode
	if ( m == NULL ){
		Noeud * pere = m->getPere();
		((Classe *) pere )->getVctMethode();
		
	}*/
	methode = m;

	setCaption("Edition du code");
	setGeometry(100,100,400,300);
	  
	/* Zone de texte */
	QGroupBox *groupCode = new QGroupBox (1, Vertical,"Code de la mthode", this, "groupCode");
	editCode = new QMultiLineEdit(groupCode,"editCode");  

	/* Grille pour placer les lments de la fentre */
	QGridLayout *grille = new QGridLayout( this, 5, 1, 1 );
	QGridLayout *bouton = new QGridLayout( 1, 3, 1);
 
	/* placement des lments */
	grille->addWidget(groupCode, 3, 0);
	grille->addLayout(bouton, 5, 0);

	QPushButton *ok = new QPushButton ( "&Ok", this, "ok");
	QPushButton *annuler = new QPushButton ( "&Annuler", this, "annuler");
	connect( ok, SIGNAL(clicked()), this, SLOT(ok()));
	connect( annuler, SIGNAL(clicked()), this, SLOT(annuler()));

	bouton->addWidget(ok, 0, 1);
	bouton->addWidget(annuler, 0, 2);

	if ( methode != NULL ) 
		editCode->insertLine( QString(methode->getCode().c_str()) );
}
void EditerCode::ok()
{	
	methode->setCode( string(editCode->text()) );
	fenetre->getNoyau()->notifier();
	if ( parentWidget() == NULL ) delete(this);
}

void EditerCode::annuler()
{
	delete(this);
}


