#ifndef FENETRERELATION_H
#define FENETRERELATION_H

#include <qwidget.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include <qmultilineedit.h>

#include <ihmfenetreprincipale.h>
#include <ihmmoncomboclasse.h>
#include <noyrelation.h>

class FenetreRelation : public QWidget
{
	Q_OBJECT

	public:
		FenetreRelation(FenetrePrincipale * fen, Relation * r=0,
				int type_relation=0, QWidget *parent=0, const char *name=0);
		virtual ~FenetreRelation() {};

		MonComboClasse *comboSource;
		QLineEdit *editSource ;

		QComboBox *comboRelation;

		MonComboClasse *comboDestination;
		QLineEdit *editDestination;

		QMultiLineEdit *editDescription;
	private:
		FenetrePrincipale *fenetre;
		Relation * relation;
	public slots:
		void annuler();
		void ok();
};

#endif

