#include <vector.h>
#include <ihmmoncomborelation.h>

MonComboRelation::MonComboRelation( FenetrePrincipale * f , QWidget * parent , const char* name ) : QComboBox(parent,name)
{
	/* parcours du vecteur de relation pour ajouter les entres du combobox */
	std::vector<Relation*>::iterator it = f->vctRelation.begin();

	while ( it != f->vctRelation.end() ) {
		this->insertItem( QString( (*it)->getNom().c_str() ) );
		++it;
	}
}

MonComboRelation::~MonComboRelation()
{

}

