#ifndef IHMMONCOMBORELATION_H
#define IHMMONCOMBORELATION_H

#include <qwidget.h>
#include <qcombobox.h>

#include <ihmfenetreprincipale.h>

/** Cette classe represente un combobox contenant les noms des relations du projet.
 * Ce combobox peut tre positionn sur une relation particulier  la cration.
 * @author F.Duchaussoy, N.Longuet, G.Prevot
 */

class MonComboRelation : public QComboBox
{
	public:

		/** Constructeur
		 * \param FenetrePrincipale *f : Reference sur la fentre principale de l'application.
		 * \param QWidget *parent : Represente le widget parent du MonComboPaquetage (Par defaut 0).
		 * \param const char *name : Represente le nom que l'on veut donner au MonComboPaquetage.
		 */
		MonComboRelation( FenetrePrincipale * f , QWidget * parent=0 , const char *name=0 );

		//! Destructeur
		virtual ~MonComboRelation( );
};

#endif

