#include <qwidget.h>
#include <qcombobox.h>
#include <ihmmoncombopaquetage.h>
#include <ihmmoncomboclasse.h>
#include <ihmmoncomborelation.h>
#include <ihmfenetreprincipale.h>

class FenetreComboPaquetage : public QWidget
{
	Q_OBJECT

	public:
		FenetreComboPaquetage(FenetrePrincipale * fen, QWidget *parent=0, const char *name=0);
		virtual ~FenetreComboPaquetage() {};

		MonComboPaquetage *comboPaquetage;
	
	private:
		FenetrePrincipale * fenetre;
	
	public slots:
		void ok();
		void annuler();
};

class FenetreComboClasse : public QWidget
{
	Q_OBJECT

	public:
		FenetreComboClasse(FenetrePrincipale * fen, QWidget *parent=0, const char *name=0);
		virtual ~FenetreComboClasse() {};

		MonComboClasse *comboClasse;
	
	private:
		FenetrePrincipale * fenetre;
	
	public slots:
		void ok();
		void annuler();
};

class FenetreComboRelation : public QWidget
{
	Q_OBJECT

	public:
		FenetreComboRelation(FenetrePrincipale * fen, QWidget *parent=0, const char *name=0);
		virtual ~FenetreComboRelation() {};

		MonComboRelation *comboRelation;
	
	private:
		FenetrePrincipale * fenetre;
	
	public slots:
		void ok();
		void annuler();
};


