#ifndef IHMVISITEURDESSIN_H
#define IHMVISITEURDESSIN_H

#include <noyvisiteurnoeud.h>
#include <noynoyau.h>

class FenetreDeDessin;

class VisiteurDessin: public VisiteurNoeud 
{
	public:
		VisiteurDessin ( Noyau * n , FenetreDeDessin * dest );
		virtual ~VisiteurDessin() {cout << "VisiteurDessin dtruit" << endl;}

		virtual void traiterProjet(Projet *p) ;

		virtual void traiterUseCase(UseCase *u) ;
		virtual void traiterCollaboration(Collaboration *c) ;
		virtual void traiterDiagrammeStatique(DiagrammeStatique *d) ;

		virtual void traiterVue(Vue *v) ;
		virtual void traiterObjetAffichable(ObjetAffichable *oa) ;
		virtual void traiterRelationCommentaire(RelationCommentaire *rc) ;
		virtual void traiterCommentaire(Commentaire *co) ;

		virtual void traiterClasse(Classe *cl) ;
		virtual void traiterPaquetage(Paquetage *pa) ;
		virtual void traiterMethode(Methode *m) ;
		virtual void traiterAttribut(Attribut *a) ;
		virtual void traiterHeritage(Heritage *h ) ;
		virtual void traiterUtilisation(Utilisation *u) ;
		virtual void traiterAssociation(Association *a) ;
		virtual void traiterAgregation(Agregation *a) ;

		
		Noyau * getNoyau() { return noyau; }
		FenetreDeDessin * getDestination() { return destination; }
	private:
		Noyau * noyau ;
		FenetreDeDessin * destination ;
};

#endif

