/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:31 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:31 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyagregation.h                         */
/************************************************/

#ifndef NOYAGREGATION_H
#define NOYAGREGATION_H
#include <iostream>
#include <noyrelation.h>

/**
 * Cette classe a pour but de modliser une agregation au sens UML du terme.
 * @author clucas - ndouay
 */
 
class Agregation:public Relation{

public:
	/**Cette methode est le constructeur d'une agregation
	* \param Noeud *pere : pointeur sur un objet de type noeud representant l'objet pre de l'agregation
	* \param const string &nom : nom donn  la relation (elle peut ne pas en avoir)
	* \param Classe *source : pointeur sur un objet de type classe designant l'origine de la relation
	* \param Classe *destination : pointeur sur un objet de type classe designant la classe pointe par la relation
	* \param const string &multipliciteSource : chane de caractres reprsentant la multiplicit de la source de la relation
	* \param const string &multipliciteDestination : chane de caractres reprsentant la multiplicit de la destination de la relation
	*/
	Agregation(Noeud *pere , const string &nom, Classe *source, Classe *destination,const string & multipliciteSource, const string &multipliciteDestination);
	
	/**Cette mthode est le destructeur d'une agrgation
	*/
	
	virtual ~Agregation();
	
	/** Cette mthode permet d'accepter un visiteur implment
	 * \param VisiteurRelation *v : visiteur propre au quatre relations uml
	 */
	virtual void accepter(VisiteurNoeud *v);
};
#endif
