/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:31 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:31 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noycharger.cpp                          */
/************************************************/


#include "noycharger.h"

#include <iostream>
#include <string>
#include <qstring.h>
#include <noynoyau.h>

#include <noystockage.h>
#include <noyvisiteurnoeud.h>
#include <noyprojet.h>
#include <noyusecase.h>
#include <noycollaboration.h>
#include <noydiagrammestatique.h>
#include <noyvue.h>
#include <noyclasse.h>
#include <noypaquetage.h>
#include <noyobjetuml.h>
#include <noyattribut.h>
#include <noymethode.h>
#include <noyrelation.h>
#include <noyheritage.h>
#include <noyassociation.h>
#include <noyagregation.h>
#include <noyutilisation.h>
#include <noyrelationcommentaire.h>
#include <noycommentaire.h>


Charger::Charger( Noyau *n )
{
	_n = n ;
	indent = "" ;
	tag_precedent = tag_courant = "";
	nb_elem = 0 ;
	n_meth = NULL ;
}
 
Charger::~Charger( )
{

}

bool Charger::startDocument()
{
	/* ON VERRA CE QU4ON FAIT LA DEDANS */
return true;
}

bool Charger::startElement( const QString& a, const QString& b, 
                                    const QString& qName, 
                                    const QXmlAttributes& c)
{
	tag_courant = string( qName.latin1() );
//	cout << "tag_courant:\"" << tag_courant << "\" et tag_precedent:\"" << tag_precedent << "\"" << endl ;

	if( tag_courant == "projet" ) {
		creerProjet( tag_courant , c );
	}

	if( tag_courant == "classe" ) {
		creerClasse( tag_courant , c );
	}

	if( tag_courant == "paquetage" ) {
		creerPaquetage( tag_courant , c );
	}

	if( tag_courant == "methode" ) {
		creerMethode( tag_courant , c );
	}

	if( tag_courant == "attribut" ) {
		creerAttribut( tag_courant , c );
	}

	if( tag_courant == "parametre" ) {
		creerParametre( tag_courant , c );
	}

	if( tag_courant == "vue" ) {
		creerVue( tag_courant , c );
	}

	if( tag_courant == "heritage" ) {
		creerHeritage( tag_courant , c );
	}

	if( tag_courant == "association" ) {
		creerAssociation( tag_courant , c );
	}

	if( tag_courant == "agregation" ) {
		creerAgregation( tag_courant , c );
	}

	if( tag_courant == "utilisation" ) {
		creerUtilisation( tag_courant , c );
	}

	if( tag_courant == "objetaffichable" ) {
		creerObjetAffichable( tag_courant , c );
	}

	if( tag_courant == "commentaire" ) {
		creerCommentaire( tag_courant , c );
	}

	if( tag_courant == "rc" ) {
		creerRelationCommentaire( tag_courant , c );
	}

	tag_precedent = tag_courant ;

    return TRUE;
}

bool Charger::endElement( const QString&, const QString&, const QString& qname )
{
	indent.remove( 0, 4 );
	/*
	 * FIXME:
	 * ATTENTION:
	 * LORSQUE TOUT MARCHERA, ON DEVRA AVOIR UNE VARIABLE GLOBALE, AFIN

	 * DE NE PAS FAIRE 12000000000000 FOIS APPEL A getXXX ICI !!!
	 */


//	cout << "END ELEMENT: "<< qname << endl; 

	Projet			*p = _n->getProjet();
	DiagrammeStatique	*d = p->getDiagrammeStatique();

	if( tag_courant == "paquetage" || tag_courant == "classe" || tag_courant== "diagrammestatique" || tag_courant == "vue" ) {
		if( n_courant != d ) {
// cout << "je remonte !! " << endl ;
			n_courant = (Noeud *)n_courant->getPere( );
		}
	}

	/* Si l'on est en train de fermer un tag de mthode alors */
	if( qname == "methode" ) {
		n_meth = NULL ;
	}

	if( qname == "commentaire" ) {
		n_comm = NULL ;
	}
	
	return TRUE;
}

void	Charger::creerProjet(const string &nom , const QXmlAttributes& a )
{
	int	i;
	string	auteur, nom_proj, version , commentaire ;
	Projet			*p ;
	DiagrammeStatique	*d ;


	for( i=0 ; i<a.length() ; i++ ){
		cout << a.qName(i) << " " << a.value(a.qName(i)) << endl;
		if( a.qName(i) == "nom" ) nom_proj = a.value(a.qName(i));
		if( a.qName(i) == "auteur" ) auteur = a.value(a.qName(i));
		if( a.qName(i) == "version" ) version = a.value(a.qName(i));
		if( a.qName(i) == "commentaire" ) commentaire = a.value(a.qName(i));
	}
	
	_n->creerProjet( nom_proj, auteur, version, commentaire );

	p = _n->getProjet( );
	d = p->getDiagrammeStatique( );
	n_courant = n_prec= d ;

}

void	Charger::creerPaquetage( const string &nom , const QXmlAttributes& a)
{
	int	i;
	string 	nom_p,id;
	Paquetage		*paq ;
	Projet			*p = _n->getProjet();
	DiagrammeStatique	*d = p->getDiagrammeStatique();


	for ( i=0 ; i<a.length() ; i++ ){
		if(a.qName(i) == "nom" ) nom_p = a.value(a.qName(i));
		if( a.qName(i) == "id" ) id = a.value(a.qName(i));
	} 


	if( tag_precedent == "attribut" || tag_precedent == "methode" ||
			tag_precedent == "parametre"  || tag_precedent == "heritage" || 
			tag_precedent== "association" || tag_precedent == "utilisation"  || tag_precedent == "agregation" ) {
		n_courant = n_courant->getPere() ;
	}

//	cout << "un paquetage" << endl ;
	if( n_courant == d ) {
		paq = new Paquetage( d , nom_p );
		d->ajouterObjetuml( paq );
		n_courant = paq ;
	} else {
		/* en supposant le fichier XML bien form */
		paq = new Paquetage( n_courant , nom_p );
		((Paquetage *)n_courant)->ajouterObjetuml( paq );
		n_courant = paq ;

	}
	vctObjet.push_back( new Objet( id , paq ) );
}

void	Charger::creerClasse( const string &nom , const QXmlAttributes& a)
{
	int	i;
	string 	nom_p,id,visible, type_cl, desc;
	bool	type = true;

	Projet			*p = _n->getProjet();
	DiagrammeStatique	*d = p->getDiagrammeStatique();
	Classe			*cla ;


	for ( i=0 ; i<a.length() ; i++ ){
		if( a.qName(i) == "nom" ) nom_p = a.value(a.qName(i));
		if( a.qName(i) == "visibilite" ) visible = a.value(a.qName(i));
		if( a.qName(i) == "type" ) {
			type_cl = a.value(a.qName(i));
			if( type_cl == "1" )
				type = true ;
			else	
				type = false ;
		}
		if( a.qName(i) == "id" ) id = a.value(a.qName(i));
		if( a.qName(i) == "description" ) desc = a.value(a.qName(i));
	} 

	id_classe_courante = id ;

	if( tag_precedent == "attribut" || tag_precedent == "methode" ||
		tag_precedent == "parametre" || tag_precedent == "heritage" || tag_precedent == "association" || 
		tag_precedent == "utilisation"  || tag_precedent == "agregation" ) {
		n_courant = n_courant->getPere() ;
	}

	if( n_courant == d ) {
		cla = new Classe( d , nom_p , visible , type );
		d->ajouterObjetuml( cla );
		n_courant = cla ;
	} else {
		/* en supposant le fichier XML bien form */
		cla = new Classe( n_courant , nom_p , visible , type );
		((Paquetage *)n_courant)->ajouterObjetuml( cla );
		n_courant = cla ;

	}
	
	cla->setDescription( desc );
// cout << "classe: " << id << " et " << cla << endl ;
	vctObjet.push_back( new Objet( id , cla ) );	
}

void	Charger::creerMethode( const string &nom , const QXmlAttributes& a)
{
	int	i;
	string 	nom_m,id,visible, type, code, desc;

	std::vector<Parametre *> vctParametre ;


	for ( i=0 ; i<a.length() ; i++ ){
		if( a.qName(i) == "nom" ) nom_m = a.value(a.qName(i));
		if( a.qName(i) == "visibilite" ) visible = a.value(a.qName(i));
		if( a.qName(i) == "type" ) type = a.value(a.qName(i));
		if( a.qName(i) == "id" ) id = a.value(a.qName(i));
		if( a.qName(i) == "code" ) code = a.value(a.qName(i));
		if( a.qName(i) == "description" ) desc = a.value(a.qName(i));
	} 

	cout << "une mthode" << endl ;
	/* On vide le vecteur */
	vctParametre.erase( vctParametre.begin() , vctParametre.end() );
	/* ------ */
	if( n_courant != NULL ) {
		n_meth =(Noeud *) ( (Classe *) n_courant)->ajouterMethode2( nom_m,type,visible,vctParametre );
		((Methode *)n_meth)->setDescription( desc );
		((Methode *)n_meth)->setCode( code );
	} else {
		cout << "ATTENTION: n_courant est NULL" << endl;
	}
	vctObjet.push_back( new Objet( id , n_meth ) );
}

void	Charger::creerAttribut( const string &nom , const QXmlAttributes& a)
{
	int	i;
	string 	nom_a,id,visible, desc;
	string	type ;
	Attribut	*att ;

	for ( i=0 ; i<a.length() ; i++ ){
		if( a.qName(i) == "nom" ) nom_a = a.value(a.qName(i));
		if( a.qName(i) == "visibilite" ) visible = a.value(a.qName(i));
		if( a.qName(i) == "type" ) type = a.value(a.qName(i));
		if( a.qName(i) == "description" ) desc = a.value(a.qName(i));
		if( a.qName(i) == "id" ) id = a.value(a.qName(i));
	} 

//	cout << "un attribut" << endl ;
	att = ((Classe *)n_courant)->ajouterAttribut2( type, nom_a, visible );
	vctObjet.push_back( new Objet( id , att ) );
}

void	Charger::creerParametre( const string &nom , const QXmlAttributes& a)
{
	int	i;
	string 	nom_p,id,visible, desc;
	string	type ;

	for ( i=0 ; i<a.length() ; i++ ){
		if( a.qName(i) == "nom" ) nom_p = a.value(a.qName(i));
		if( a.qName(i) == "type" ) type = a.value(a.qName(i));
	}

	if( n_meth != NULL ) {
		cout << "un parametre" << endl;
		( (Methode *)n_meth)->ajouterParametre( new Parametre( nom_p , type  )) ;
	} else {
		cout << "ATTENTION: n_meth est NULL" << endl;
	}
}

void	Charger::creerVue( const string &nom , const QXmlAttributes& a)
{
	int	i;
	string 	nom_v,id,visible, desc;
	string	type ;
	Vue		*v ;

	Projet			*p = _n->getProjet();
	DiagrammeStatique	*d = p->getDiagrammeStatique();

	cout << "on ajoute une vue" << endl ;

	for ( i=0 ; i<a.length() ; i++ ){
		if( a.qName(i) == "nom" ) nom_v = a.value(a.qName(i));
	}

	if( d != NULL ) {
		v = new Vue( d , nom_v );
// cout << "vue: " << v << endl;
		d->ajouterVue( v );
		n_courant = v ;
	}
}

void	Charger::creerObjetAffichable( const string &nom , const QXmlAttributes& a)
{
	int	i;
	string 	nom_v,id,visible, desc;
	string	type ;
	string	x,y,w,h ;
	bool		b ;

	for ( i=0 ; i<a.length() ; i++ ){
		if( a.qName(i) == "nom" ) nom_v = a.value(a.qName(i));
		if( a.qName(i) == "x" ) x = a.value(a.qName(i));
		if( a.qName(i) == "y" ) y = a.value(a.qName(i));
		if( a.qName(i) == "w" ) w = a.value(a.qName(i));
		if( a.qName(i) == "h" ) h = a.value(a.qName(i));
		if( a.qName(i) == "visible" ) visible = a.value(a.qName(i));
		if( a.qName(i) == "id" ) id = a.value(a.qName(i));
	}

	if( n_courant != NULL ) {
		std::vector<Objet *>::iterator it ;
		it = vctObjet.begin();
		
		while( it != vctObjet.end() ){
			if( (*it)->getID() == id ) {
				break;
			}
		++ it ;
		}
		
		visible == "1" ? b = true : b = false ;		

//		cout << "on ajoute un objet affichable" << endl;

cout << (ElementDeModelisation*)(*it)->getEDM() << " et " << n_courant  << endl;
		( (Vue *)n_courant)->ajouterObjetAffichable( new
			ObjetAffichable( (ElementDeModelisation*)(*it)->getEDM() , atoi(x.c_str()) ,  atoi(y.c_str()),
						atoi(w.c_str()) , atoi(h.c_str()) , b  , n_courant )  );		
//		cout << " apres ajout obj aff " << endl ;
	}

}

void	Charger::creerHeritage( const string &nom , const QXmlAttributes& a)
{
	int	i;
	string 	nom_h, id, source, dest, multsource, multdest, desc;
	string n ;

	Relation		*h ;

	for ( i=0 ; i<a.length() ; i++ ){
		if( a.qName(i) == "nom" ) nom_h = a.value(a.qName(i));
		if( a.qName(i) == "source" ) source = a.value(a.qName(i));
		if( a.qName(i) == "destination" ) dest = a.value(a.qName(i));
		if( a.qName(i) == "multiplicitesource" ) multsource = a.value(a.qName( i ));
		if( a.qName(i) == "multiplicitedestination" ) multdest = a.value(a.qName(i));
		if( a.qName(i) == "description" ) desc = a.value(a.qName(i));
		if( a.qName(i) == "id" ) id = a.value(a.qName(i));
	}

	if( id_classe_courante  == source ) {
		if( n_courant != NULL ) {
			h = ((Classe *)n_courant)->ajouterRelation( new Heritage( (Noeud*)n_courant , nom_h ,  (Classe *)n_courant  , (Classe *)NULL ) ) ;
			h->setNom( "Hritage de la classe mre " );
			h->setDescription( desc ); 
		}
		/* on ajoute au vecteur d'objetrelation, pour garder une trace de cette relation */
// cout << "on ajoute la relation avec les infos suivantes: " << "id_classe_source: " << id_classe_courante << " " <<  id << " " << source << " " << dest << " et finalement " << h->getId() << endl;
		vctObjetRelation.push_back( new ObjetRelation(id, h , source, dest ) );
		/* on ajoute au vecteur d'objet afin de le traiter ensuite dans les vues */
		vctObjet.push_back( new Objet( id , h ) ) ;
	}
}

void	Charger::creerAssociation( const string &nom , const QXmlAttributes& a)
{
	int	i;
	string 	nom_h, id, source, dest, multsource, multdest, desc;
	string n ;

	Relation		*h ;

	for ( i=0 ; i<a.length() ; i++ ){
		if( a.qName(i) == "nom" ) nom_h = a.value(a.qName(i));
		if( a.qName(i) == "source" ) source = a.value(a.qName(i));
		if( a.qName(i) == "destination" ) dest = a.value(a.qName(i));
		if( a.qName(i) == "multiplicitesource" ) multsource = a.value(a.qName( i ));
		if( a.qName(i) == "multiplicitedestination" ) multdest = a.value(a.qName(i));
		if( a.qName(i) == "description" ) desc = a.value(a.qName(i));
		if( a.qName(i) == "id" ) id = a.value(a.qName(i));
	}

	if( id_classe_courante == source ) {
	
		if( n_courant != NULL ) {
			h = ((Classe *)n_courant)->ajouterRelation( new Association( (Noeud*)n_courant , nom_h ,  (Classe *)n_courant  , (Classe *)NULL, multsource, multdest ) ) ;
			h->setNom( "Association entre " );
			h->setDescription( desc ); 
		}
		/* on ajoute au vecteur d'objetrelation, pour garder une trace de cette relation */
// cout << "on ajoute la relation avec les infos suivantes: " << "id_classe_source: " << id_classe_courante << " " <<  id << " " << source << " " << dest << " et finalement " << h->getId() << endl;
		vctObjetRelation.push_back( new ObjetRelation(id, h , source, dest ) );
		/* on ajoute au vecteur d'objet afin de le traiter ensuite dans les vues */
		vctObjet.push_back( new Objet( id , h ) ) ;
	}
}



void	Charger::creerUtilisation( const string &nom , const QXmlAttributes& a)
{
	int	i;
	string 	nom_h, id, source, dest, multsource, multdest, desc;
	string n ;

	Relation		*h ;

	for ( i=0 ; i<a.length() ; i++ ){
		if( a.qName(i) == "nom" ) nom_h = a.value(a.qName(i));
		if( a.qName(i) == "source" ) source = a.value(a.qName(i));
		if( a.qName(i) == "destination" ) dest = a.value(a.qName(i));
		if( a.qName(i) == "multiplicitesource" ) multsource = a.value(a.qName( i ));
		if( a.qName(i) == "multiplicitedestination" ) multdest = a.value(a.qName(i));
		if( a.qName(i) == "description" ) desc = a.value(a.qName(i));
		if( a.qName(i) == "id" ) id = a.value(a.qName(i));
	}

	if( id_classe_courante == source ) {
// cout << "on a id_classe_courante == source " << endl;
		if( n_courant != NULL ) {
			h = ((Classe *)n_courant)->ajouterRelation( new Utilisation( (Noeud*)n_courant , nom_h ,  (Classe *)n_courant  , (Classe *)NULL, multsource, multdest ) ) ;
			h->setNom( "Utilisation entre " );
			h->setDescription( desc ); 
		}
		/* on ajoute au vecteur d'objetrelation, pour garder une trace de cette relation */
// cout << "on ajoute la relation avec les infos suivantes: " << "id_classe_source: " << id_classe_courante << " " <<  id << " " << source << " " << dest << " et finalement " << h->getId() << endl;
		vctObjetRelation.push_back( new ObjetRelation(id, h , source, dest ) );
		/* on ajoute au vecteur d'objet afin de le traiter ensuite dans les vues */
		vctObjet.push_back( new Objet( id , h ) ) ;
	}
}

void	Charger::creerAgregation( const string &nom , const QXmlAttributes& a)
{
	int	i;
	string 	nom_h, id, source, dest, multsource, multdest, desc;
	string n ;

	Relation		*h ;

	for ( i=0 ; i<a.length() ; i++ ){
		if( a.qName(i) == "nom" ) nom_h = a.value(a.qName(i));
		if( a.qName(i) == "source" ) source = a.value(a.qName(i));
		if( a.qName(i) == "destination" ) dest = a.value(a.qName(i));
		if( a.qName(i) == "multiplicitesource" ) multsource = a.value(a.qName( i ));
		if( a.qName(i) == "multiplicitedestination" ) multdest = a.value(a.qName(i));
		if( a.qName(i) == "description" ) desc = a.value(a.qName(i));
		if( a.qName(i) == "id" ) id = a.value(a.qName(i));
	}

	if( id_classe_courante == source ) {
		if( n_courant != NULL ) {
			h = ((Classe *)n_courant)->ajouterRelation( new Agregation( (Noeud*)n_courant , nom_h ,  (Classe *)n_courant  , (Classe *)NULL, multsource, multdest ) ) ;
			h->setNom( "Agregation entre " );
			h->setDescription( desc ); 
		}
		/* on ajoute au vecteur d'objetrelation, pour garder une trace de cette relation */
// cout << "on ajoute la relation avec les infos suivantes: " << "id_classe_source: " << id_classe_courante << " " <<  id << " " << source << " " << dest << " et finalement " << h->getId() << endl;
		vctObjetRelation.push_back( new ObjetRelation(id, h , source, dest ) );
		/* on ajoute au vecteur d'objet afin de le traiter ensuite dans les vues */
		vctObjet.push_back( new Objet( id , h ) ) ;
	}
}

void	Charger::creerCommentaire( const string &nom , const QXmlAttributes& a)
{
	int		i;
	string 		nom_v,id,visible, commentaire;
	string		type ;
	string		x,y,w,h ;
	bool		b ;
	Commentaire	*c ;

	for ( i=0 ; i<a.length() ; i++ ){
		if( a.qName(i) == "nom" ) nom_v = a.value(a.qName(i));
		if( a.qName(i) == "x" ) x = a.value(a.qName(i));
		if( a.qName(i) == "y" ) y = a.value(a.qName(i));
		if( a.qName(i) == "w" ) w = a.value(a.qName(i));
		if( a.qName(i) == "h" ) h = a.value(a.qName(i));
		if( a.qName(i) == "visible" ) visible = a.value(a.qName(i));
		if( a.qName(i) == "id" ) id = a.value(a.qName(i));
		if( a.qName(i) == "commentaire" ) commentaire = a.value(a.qName(i));
	}

	if( n_courant != NULL ) {
		visible == "1" ? b = true : b = false ;		
		c = new Commentaire( commentaire );
	//	cout << "on ajoute un commentaire:" << c  << endl;
		c->setNom( nom_v );
		( (Vue *)n_courant)->ajouterElementDeModelisation( c , atoi(x.c_str()) ,  atoi(y.c_str()), atoi(w.c_str()) , atoi(h.c_str()) , b ) ;
		n_comm = c ;
		c->setPere( n_courant );
	}
}

void	Charger::creerRelationCommentaire( const string &nom , const QXmlAttributes& a)
{
	int	i;
	string 	nom_v,id,visible, destination;

	for ( i=0 ; i<a.length() ; i++ ){
		if( a.qName(i) == "nom" ) nom_v = a.value(a.qName(i));
		if( a.qName(i) == "destination" ) destination = a.value(a.qName(i));
		if( a.qName(i) == "id" ) id = a.value(a.qName(i));
	}

	if( n_comm != NULL ) {
		std::vector<Objet *>::iterator it ;
		it = vctObjet.begin();

		while( it != vctObjet.end() ){
			if( (*it)->getID() == destination ) {
				break;
			}
		++ it ;
		}
//		cout << "on ajoute une relationcommentaire add commentaire:" << n_comm << " de nom: " << n_comm->getNom() <<" et " << (Noeud *)(*it)->getEDM() << endl;
		((Commentaire *)n_comm)->ajouterRelationCommentaire( nom_v , (Noeud *)(*it)->getEDM( ) );
	}
}

/**
 * Cette classe permet de dterminer le type de relation afin de crer le 
 * nom de la relation
 */
class VisiteurTypeRelation : public VisiteurNoeud
{
public:
	bool	type ;

	VisiteurTypeRelation( ){ }
	virtual ~VisiteurTypeRelation( ){ }
	void traiterHeritage( Heritage *h ){
		type = true ;
	}
	
	void traiterAssocation( Association *h ){
		type = false ;
	}
	
	void traiterUtilisation( Utilisation *h ){
		type = false ;
	}
	void traiterAgregation( Agregation *h ){
		type = false ;
	}
};


void	Charger::majRelation( )
{
	string 		id ;
	string 		nom ;
	Classe		*s , *d ;
	Relation	*r ;
	
	VisiteurTypeRelation *rtr = new VisiteurTypeRelation( );

	std::vector<Objet *>::iterator itObjet;
	std::vector<ObjetRelation *>::iterator itObjetRelation ;
	itObjetRelation = vctObjetRelation.begin();

	while( itObjetRelation != vctObjetRelation.end() ) {
		id = (*itObjetRelation)->getDEST();
		
		itObjet = vctObjet.begin() ;
		while( itObjet != vctObjet.end() ) {
			if( id == (*itObjet)->getID() ) {
				break ;
			}		
		++ itObjet ;
		}
		
		r = (*itObjetRelation)->getRelation(); 
		r->setClasseDestination( (Classe *)(*itObjet)->getEDM() );
	
		s = r->getClasseSource() ;
                d = r->getClasseDestination() ;

		r->accepter( rtr );

		if( rtr->type == true ) {
			nom = r->getNom( );
			nom += d->getNomComplet() ;
			r->setNom( nom  );
		} else {
			nom = r->getNom( );
			nom += d->getNomComplet() ;
			nom += " et " ;
			nom += s->getNomComplet();
			r->setNom( nom ) ;
		}
	
// cout << "avant ajoUterRelationExterieure" << "et " << s->getNom() << " et " << d->getNom() << endl;
		s->ajouterRelationExterieure( d , r );

	++itObjetRelation ;
	}
	
}


void Charger::verif( )
{
	Projet 	*p = _n->getProjet( );
	DiagrammeStatique	*d = p->getDiagrammeStatique( );
	std::vector<Vue *> vctv = d->getVctVue( );
	std::vector<Vue *>::iterator it ;
	
	it = vctv.begin();
	while( it != vctv.end() ) {
		std::vector<ObjetAffichable *> vctO = (*it)->getvctObjetAffichable( );
		std::vector<ObjetAffichable *>::iterator it2 ;
		it2 = vctO.begin();

		while( it2 != vctO.end() ) {
			if( (*it2)->getedm()->getPere() == (*it) ) {
				
				std::vector<RelationCommentaire *> vctRC = ((Commentaire *)(*it2))->getvctRelCom( );
				std::vector<RelationCommentaire *>::iterator it3 ;
				it3 = vctRC.begin();

				while( it3 != vctRC.end() ) {
					cout << (*it3)->getNom() << endl;
				++it3;
				}

			} else {
 				cout << "ObjetAffichable" << endl;
			}
		++it2 ;
		}
	++it ;
	}
	
}

bool Charger::characters ( const QString & ch ) {
	if( (unsigned int )ch.find("\n") == string::npos ) { 
		cout << "dans " << tag_courant << " : caractres lus: \"" << ch << "\"" << endl; 
	}
	
return TRUE ;
}

bool Charger::ignorableWhitespace ( const QString & ch )
{
	cout << "ignorable whitespace" << endl ;
return TRUE ;
}

bool Charger::processingInstruction ( const QString & target, const QString & data )
{
//	cout << "Processing Instruction: " << target << " " << data << endl ;
return TRUE ;
}

QString Charger::errorString ()
{
	return "Un des handlers a retourn un FALSE" ;
}


/*****************************************************************************************************************************************************
 *****************************************************************************************************************************************************
 *****************************************************************************************************************************************************/


ErrorHandler::ErrorHandler( )
{

}

bool ErrorHandler::error( const QXmlParseException & exception ) 
{
	cout << exception.lineNumber() << endl ;
return true ;
}

bool ErrorHandler::fatalError( const QXmlParseException & exception ) 
{
	cout << "FATAL ERROR!!!" << exception.lineNumber() << " et " << exception.columnNumber() << endl ;
return true ;
}

bool ErrorHandler::warning( const QXmlParseException & exception ) 
{
	cout << "WARNING!!!" << exception.lineNumber() << endl ;
return true ;
}

