/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:34 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:34 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noycommentaire.cpp                            */
/************************************************/

#include <iostream.h>
#include <string.h>
#include <vector.h>
#include <noydiagrammestatique.h>
#include <noyrelationcommentaire.h>

Commentaire::Commentaire( const string & c ):ElementDeModelisation(0,"")
{
	_commentaire = c ;
}

Commentaire::~Commentaire()
{
	Vue *v = (Vue *)this->getPere();
	v->supprimerCommentaire( this );
}

void Commentaire::accepter( VisiteurNoeud *v )
{
	v->traiterCommentaire( this );
}		

bool	Commentaire::ajouterRelationCommentaire( const string &nom, Noeud * noeud )
{
	RelationCommentaire * r = new RelationCommentaire( this , nom , this , noeud );

	std::vector<RelationCommentaire*> v = getvctRelCom();
	v.push_back(r);
	setvctRelCom(v);

	return true;
}

void Commentaire::supprimerRelationCommentaire(RelationCommentaire *r)
{
	std::vector<RelationCommentaire*> v;
	std::vector<RelationCommentaire*>::iterator it;
	
	// on supprime la relation du vecteur
	v = getvctRelCom();
	it = v.begin();
	while((it != v.end()) ) {
		if( *it == r ) {
			v.erase(it);
			setvctRelCom(v);
			break;
		}
		++it;
	}
	delete(r);
}
		
void Commentaire::setCommentaire( const string & c )
{
	_commentaire = c ;
}

string Commentaire::getCommentaire( ) 
{
	return _commentaire;
}

std::vector<RelationCommentaire *> Commentaire::getvctRelCom()
{
	return vctRelCom;
}
		
void Commentaire::setvctRelCom(std::vector<RelationCommentaire *> v)
{
	vctRelCom = v;
}
