/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:35 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:35 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyelementdemodelisation.cpp                            */
/************************************************/

#include <noyelementdemodelisation.h>
#include <noydiagrammestatique.h>
#include <noyclasse.h>

ElementDeModelisation::ElementDeModelisation(Noeud* pere,const string &nom):Noeud(pere,nom) {}

ElementDeModelisation::~ElementDeModelisation() {}

// Cette classe a pour but de rcuprer un diagramme statique
//  partir d'un paquetage...
class VisiteurDiag : public VisiteurNoeud {
	public:
		DiagrammeStatique *tmp_d ;
		VisiteurDiag( ) { tmp_d = NULL ; }
		virtual ~VisiteurDiag(){}

		void traiterPaquetage(Paquetage *p) {
			p->getPere()->accepter(this) ;
		}

		void traiterClasse(Classe *c) {
			c->getPere()->accepter(this);
		}

		void traiterRelation( Relation *r ) {
			r->getPere()->accepter(this);
		}

		void traiterDiagrammeStatique(DiagrammeStatique *dg) {
			tmp_d = dg ;
		}
};


// permet de rcuprer le diagramme statique...
DiagrammeStatique* ElementDeModelisation::getDiagrammeStatique()
{
	VisiteurDiag		vd ;
	accepter( &vd );
	if( vd.tmp_d != NULL ) {
		return vd.tmp_d ;
	} else {
		return NULL ;
	}
}
