/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:36 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:36 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyheritage.h                           */
/************************************************/

#ifndef NOYHERITAGE_H
#define NOYHERITAGE_H
#include <iostream>
#include <noyrelation.h>

/**
 * Cette classe a pour but de modliser un hritage au sens UML du terme.
 * @author clucas - ndouay
 */
class Heritage:public Relation{

public:

	/**Cette methode est le constructeur d'un hritage
	* \param Noeud *pere : pointeur sur un objet de type noeud representant l'objet pre de l'hritage
	* \param const string &nom : nom donn  la relation (elle peut ne pas en avoir)
	* \param Classe *source : pointeur sur un objet de type classe designant l'origine de la relation
	* \param Classe *destination : pointeur sur un objet de type classe designant la classe pointe par la relation
	*/
	Heritage(Noeud *pere , const string &nom, Classe *source, Classe *destination);
	
	/**Cette mthode est le destructeur d'une relation d'hritage
	*/
	virtual ~Heritage();
	
	/** Cette mthode permet d'accepter un visiteur implment
	* \param VisiteurRelation *v : visiteur propre au quatre relation uml
	*/
	virtual void accepter( VisiteurNoeud *v );
};
#endif
