/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:36 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:36 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noymethode.cpp                          */
/************************************************/

#include <noymethode.h>

Methode::Methode(Noeud *pere,const string &nom,const string &visible,const string &typeRetour)
:Noeud(pere,nom)
{
	setVisible(visible);
	setTypeRetour(typeRetour);
	_code = "";
}

Methode::~Methode() {}

bool Methode::ajouterParametre(Parametre* p)
{
	std::vector<Parametre*>::iterator it;
	it=vctParametre.begin();
	while((it != vctParametre.end()) ) {
		if( (*it)->getNom() == p->getNom() ) {
			return false ;
		}

		++it;
	}
	vctParametre.push_back(p);
return true;
}

bool Methode::supprimerParametre(Parametre *p)
{
	std::vector<Parametre*>::iterator it;
	it=vctParametre.begin();
	while((it != vctParametre.end()) ){
		if( *it == p ) {
			vctParametre.erase(it);
			return true ;
		}
		++it;
	}
return false ;
}

void Methode::setVisible(const string &visible)
{
	_visible = visible;
}

void Methode::setTypeRetour(const string &typeRetour)
{
	_typeRetour = typeRetour;
}

string Methode::getVisible()
{
	return _visible;
}

string Methode::getTypeRetour()
{
	return _typeRetour;
}

string Methode::petiteChaine()
{
	if (getVisible() == "Public") return "+" +getNom();
	if (getVisible() == "Protected") return "#" +getNom();
	else return "-" +getNom();
}

string Methode::grandeChaine()
{
	string retour ;

	std::vector<Parametre*>::iterator it;
	it = vctParametre.begin();
	string s(""); 
	if (it != vctParametre.end()){
		s = (string) (*it)->getType() + " " + (string) (*it)->getNom();
		++it;
	}
	while(it != vctParametre.end())
	{
		s += " , ";
		s += (string) (*it)->getType() + " " + (string) (*it)->getNom();
		++it;
	}

	if( getVisible() == "public" ) {
		retour = "+" ;
	} else {
		if( getVisible() == "protected" ) {
			retour = "#" ;
		}else{
			retour = "-" ;
		}
	}
	return retour + " " + getTypeRetour() + " " + getNom() + " ( " + s + " ) ";
}

void Methode::cloneVctParametre( std::vector<Parametre*> & v )
{
	v = vctParametre ;
}

void Methode::accepter(VisiteurNoeud *v)
{
	v->traiterMethode(this);
}

void Methode::setCode( const string &code )
{
	_code = code ;
}

string Methode::getCode()
{
	return _code ;
}
