/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:38 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:38 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyobjetaffichable.cpp                            */
/************************************************/

#include <noyobjetaffichable.h>

ObjetAffichable::ObjetAffichable(ElementDeModelisation* edm):Noeud(0,"")
{
	_edm = edm;
}

ObjetAffichable::ObjetAffichable(ElementDeModelisation	*edm, int x, int y , int largeur, int hauteur , bool visible , Noeud *n):Noeud(n,"")
{
	_edm = edm ;
	_x = x ;
	_y = y ;
	_largeur = largeur ;
	_hauteur = hauteur ;
	_visible = visible ;
}

ObjetAffichable::~ObjetAffichable() {}

void 	ObjetAffichable::accepter(VisiteurNoeud* v) 
{
	v->traiterObjetAffichable(this);
}

void ObjetAffichable::modifierCoordonnees( int x , int y )
{
	_x = x ;
	_y = y ;
}

void ObjetAffichable::modifierDimension( int largeur , int hauteur )
{
	_largeur = largeur ;
	_hauteur = hauteur ;
}

void ObjetAffichable::modifierVisibilite( bool v )
{
	_visible = v ;
}

ElementDeModelisation*	ObjetAffichable::getedm()
{
	return _edm;
}


int	ObjetAffichable::getX()
{
	return _x;
}

int	ObjetAffichable::getY()
{
	return _y;
}

int	ObjetAffichable::getLargeur()
{
	return _largeur;
}

int	ObjetAffichable::getHauteur()
{
	return _hauteur;
}

bool	ObjetAffichable::getVisible()
{
	return _visible;
}
