/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:39 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:39 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noypaquetage.cpp                            */
/************************************************/

#include <noypaquetage.h>
#include <noydiagrammestatique.h>

// Implmentations des mthodes de Paquetage.
Paquetage::Paquetage(Noeud* pere,const string &nom):Objetuml(pere,nom) {}

Paquetage::~Paquetage() {
	DiagrammeStatique	*d ;

	std::vector<Objetuml*>::iterator it;
	it = vctObjetuml.begin();
	while( (it != vctObjetuml.end()) ){
		delete *it;
		++it;
	}
	// Supprimer dans toutes les vues.
	d = getDiagrammeStatique();
	// Pour chaque vue, je regarde si j'existe dans celle-ci !
	std::vector<Vue*>::iterator it_vue;
	std::vector<Vue*> v = d->getVctVue();
	it_vue = v.begin();
	while( it_vue != v.end() ){
		// Dans chaque vue, je regarde si j'apparais !
/*		std::vector<ObjetAffichable*>::iterator it2;
		std::vector<ObjetAffichable*> obj = (*it_vue)->getvctObjetAffichable(); 
		it2 = obj.begin() ;
		while( it2 != obj.end() ) {
			ElementDeModelisation *e ;
			e = (*it2)->getedm();
			if( e == this ) {
				obj.erase( it2 );
			}
		++it2 ;
		}
*/
		(*it_vue)->supprimerPaquetage( this );
	++it_vue;
	}
}

void Paquetage::accepter(VisiteurNoeud* v)
{
	v->traiterPaquetage(this);
}

bool Paquetage::ajouterObjetuml(Objetuml* ob)
{
	std::vector<Objetuml*>::iterator it;
	it = vctObjetuml.begin();
	while((it != vctObjetuml.end()) ){
		if( *it == ob ) {
			return false ;
		}
	++it;
	}
	vctObjetuml.push_back(ob);
return true;
}

bool Paquetage::supprimerObjetuml(Objetuml* ob)
{
	std::vector<Objetuml*>::iterator it;
	it = vctObjetuml.begin();
	while((it != vctObjetuml.end()) ){
		if( *it == ob ) {
			// tuer sa descendance...
			delete ob;
			// On vire l'objet du vecteur de paquetages
			vctObjetuml.erase(it); 
			return true ;
		}
		++it;
	}
return false ;
}

bool Paquetage::enleverObjetuml(Objetuml* ob)
{
	std::vector<Objetuml*>::iterator it;
	it = vctObjetuml.begin();
	while((it != vctObjetuml.end()) ){
		if( *it == ob ) {
			// On vire l'objet du vecteur de paquetages
			vctObjetuml.erase(it); 
			return true ;
		}
		++it;
	}
return false ;
}

void Paquetage::visiterObjetuml(VisiteurNoeud* v)
{
	std::vector<Objetuml*>::iterator it;
	it = vctObjetuml.begin();
	while(it != vctObjetuml.end()) {
		((Objetuml*) *it)->accepter(v);
		++it;
	}
}

Objetuml* Paquetage::possedeObjetuml( Objetuml *o )
{
	std::vector<Objetuml*>::iterator it;
	it=vctObjetuml.begin();
	while((it != vctObjetuml.end()) ) {
		if( *it == o ) {
			return *it ;
		}
		++it;
	}
return NULL;
}

std::vector<Objetuml *> Paquetage::getVctObjetuml()
{
	return vctObjetuml;
}
