/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:43 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:43 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyutilisation.h                        */
/************************************************/

#ifndef NOYUTILISATION_H
#define NOYUTILISATION_H
#include <iostream>
#include <noyrelation.h>

/**Cette classe reprsente une utilisation au sens UML du terme.
* @author clucas - ndouay
*/
class Utilisation:public Relation{

public:

	/**Cette methode est le constructeur d'une utilisation
	* \param Noeud *pere : pointeur sur un objet de type noeud representant l'objet pre de l'utilisation
	* \param const string &nom : nom donn  la relation (elle peut ne pas en avoir)
	* \param Classe *source : pointeur sur un objet de type classe designant l'origine de la relation
	* \param Classe *destination : pointeur sur un objet de type classe designant la classe pointe par la relation
	*/
	Utilisation(Noeud *pere , const string &nom, Classe *source, Classe *destination,const string & multipliciteSource, const string &multipliciteDestination);
	
	/**Cette mthode est le destructeur d'une utilisation
	*/
	virtual ~Utilisation();
	
	/** Cette mthode permet d'accepter un visiteur implment
	* \param VisiteurRelation *v : visiteur propre au quatre relation uml
	*/
	virtual void accepter(VisiteurNoeud *v);
};
#endif
