
/*  A Bison parser, made from parsersyncpp.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse cppparse
#define yylex cpplex
#define yyerror cpperror
#define yylval cpplval
#define yychar cppchar
#define yydebug cppdebug
#define yynerrs cppnerrs
#define	END_OF_FILE	257
#define	UNDEF_IDENTIFIANT	258
#define	IDENTIFIANT_NAMESPACE	259
#define	IDENTIFIANT_CLASS	260
#define	IDENTIFIANT_METHODE	261
#define	IDENTIFIANT_ATTRIBUT	262
#define	KW_namespace	263
#define	KW_class	264
#define	KW_struct	265
#define	KW_union	266
#define	KW_using	267
#define	KW_22points	268
#define	KW_public	269
#define	KW_private	270
#define	KW_protected	271
#define	KW_type	272
#define	KW_typedef	273
#define	KW_AbstractMethode	274
#define	KW_while	275
#define	KW_for	276
#define	KW_if	277
#define	KW_else	278
#define	KW_return	279
#define	KW_include	280
#define	KW_ifndef	281
#define	KW_define	282
#define	KW_ifdef	283
#define	KW_endif	284
#define	KW_extern	285
#define	KW_EXTERN_C	286

#line 1 "parsersyncpp.y"

#include <iostream>
#include <stdio.h>
#include <stdlib.h>

#include <parparser.h>

#define CONF_TEST

PileCS pileCS;

void cpperror (char *s)
	{
	string sLigne;
	char cpLigne[15];
	istream in;
	cerr << s << "  la ligne " << ligne << endl;
	snprintf(cpLigne,15,"%d",ligne);
	erreur.text = string(s) + string("  la ligne ") + string(cpLigne) ;
	}

extern int cpplex();
extern FILE *cppin;

class AfficheurArbreSyntaxique : public VisiteurNoeudSyntaxique {
	public:
		virtual void traiterContexteSemantique(ContexteSemantique *cs) 
			{
				cout << "cs:" << cs->getNomComplet() << endl;
				cs->visiterNS(this);
			}
						
		virtual void traiterNsClasse(NsClasse *nsc)
			{
				cout << "nsc:" << nsc->getNomComplet() << endl;
				nsc->visiterNS(this);
			}
			
		virtual void traiterNsPaquetage(NsPaquetage *nsp)
			{
				cout << "nsp:" << nsp->getNomComplet() << endl;
				nsp->visiterNS(this);
			}
			
		virtual void traiterNsMethode(NsMethode *nsm)
			{
				cout << "nsm:" << nsm->getNomComplet() << endl;		
			}
		
		virtual void traiterNsAttribut(NsAttribut *nsa)
			{
				cout << "nsa:" << nsa->getNomComplet() << endl;
			}
	};


#line 58 "parsersyncpp.y"
typedef union {
	ContexteSemantique *cs;
	NsClasse *nsc;
	NsPaquetage *nsp;
	NsMethode *nsm;
	NoeudSyntaxique *ns;
	Type *type;
	Chaine identifiant;
	void *contexte;
	unsigned int val;
	} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		169
#define	YYFLAG		-32768
#define	YYNTBASE	42

#define YYTRANSLATE(x) ((unsigned)(x) <= 286 ? yytranslate[x] : 97)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    38,
    39,    41,     2,    36,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    37,    35,     2,
    40,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    33,     2,    34,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     3,     6,     7,     8,    17,    20,    21,    26,
    29,    35,    36,    44,    49,    52,    53,    56,    57,    61,
    62,    67,    68,    75,    76,    82,    83,    89,    90,    94,
    95,    96,   100,   101,   103,   104,   109,   112,   113,   118,
   119,   124,   125,   130,   134,   135,   137,   138,   142,   143,
   147,   150,   152,   154,   156,   157,   158,   162,   165,   166,
   167,   175,   176,   178,   179,   182,   183,   184,   191,   193,
   194,   195,   199,   201,   203,   206,   209,   210,   212,   214,
   217,   221,   223,   224,   226,   228,   230,   232,   234,   236,
   238,   240,   242,   244,   245,   250,   252,   253,   258,   260,
   262,   263
};

static const short yyrhs[] = {     3,
     0,     0,    43,    44,     0,     0,     0,     9,    89,    45,
    33,    44,    34,    46,    59,     0,    70,    59,     0,     0,
    51,    35,    47,    59,     0,    70,    59,     0,    32,    33,
    44,    34,    44,     0,     0,    19,    18,    84,     4,    35,
    48,    44,     0,    19,    93,     4,    35,     0,     1,    35,
     0,     0,     4,    50,     0,     0,    36,     4,    50,     0,
     0,    10,    91,    52,    55,     0,     0,    19,    11,    57,
    53,    56,    49,     0,     0,    11,    57,    54,    56,    49,
     0,     0,    66,    33,    65,    34,    49,     0,     0,    33,
    65,    34,     0,     0,     0,    91,    58,    66,     0,     0,
    44,     0,     0,    51,    35,    61,    65,     0,    70,    65,
     0,     0,    15,    37,    62,    65,     0,     0,    17,    37,
    63,    65,     0,     0,    16,    37,    64,    65,     0,     1,
    35,    59,     0,     0,    60,     0,     0,    37,    68,    67,
     0,     0,    36,    68,    67,     0,    69,    93,     0,    15,
     0,    17,     0,    16,     0,     0,     0,    83,    71,    72,
     0,    86,    35,     0,     0,     0,    95,    38,    73,    75,
    39,    74,    81,     0,     0,    77,     0,     0,    36,    77,
     0,     0,     0,    83,    78,    88,    80,    79,    76,     0,
    40,     0,     0,     0,    33,    82,    34,     0,    35,     0,
    20,     0,    85,    84,     0,    41,    84,     0,     0,    18,
     0,    93,     0,    88,    87,     0,    86,    36,    86,     0,
    40,     0,     0,     4,     0,     8,     0,     7,     0,     6,
     0,     5,     0,     4,     0,     5,     0,     5,     0,     6,
     0,     4,     0,     0,    90,    14,    92,    91,     0,     6,
     0,     0,    90,    14,    94,    93,     0,     4,     0,     7,
     0,     0,    90,    14,    96,    95,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   127,   129,   133,   140,   144,   150,   150,   151,   158,   158,
   159,   160,   168,   168,   172,   178,   179,   185,   186,   192,
   198,   198,   202,   203,   207,   211,   212,   215,   216,   219,
   223,   228,   231,   232,   236,   243,   243,   244,   249,   249,
   254,   254,   259,   259,   265,   266,   269,   271,   276,   278,
   282,   288,   289,   290,   291,   296,   303,   307,   309,   316,
   326,   332,   334,   337,   339,   342,   347,   352,   354,   359,
   362,   368,   368,   369,   376,   386,   390,   396,   401,   408,
   410,   413,   416,   419,   426,   431,   436,   441,   449,   455,
   461,   466,   472,   478,   483,   489,   494,   499,   505,   510,
   514,   519
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","END_OF_FILE",
"UNDEF_IDENTIFIANT","IDENTIFIANT_NAMESPACE","IDENTIFIANT_CLASS","IDENTIFIANT_METHODE",
"IDENTIFIANT_ATTRIBUT","KW_namespace","KW_class","KW_struct","KW_union","KW_using",
"KW_22points","KW_public","KW_private","KW_protected","KW_type","KW_typedef",
"KW_AbstractMethode","KW_while","KW_for","KW_if","KW_else","KW_return","KW_include",
"KW_ifndef","KW_define","KW_ifdef","KW_endif","KW_extern","KW_EXTERN_C","'{'",
"'}'","';'","','","':'","'('","')'","'='","'*'","CPPFILE","@1","CORP_DECLARATIF",
"@2","@3","@4","@5","LIST_ALIAS_OPT","LIST_ALIAS","KW_DECLARATION_CLASS","@6",
"@7","@8","OPT_DESCRIPTION_CLASS","OPT_DESCRIPTION_STRUCT","OPT_NOUVEL_IDENTIFIANT_CLASS",
"@9","APRES_CORP_DECLARATIF","CORP_DECLARATIF_CLASS","@10","@11","@12","@13",
"APRES_CORP_DECLARATIF_CLASS","HERITE_DE","HERITE_DE_V","DECLARE_HERITAGE","VISIBILITE_HERITAGE",
"DECLARATION","@14","DECL_METHODE_OU_VARIABLE","@15","@16","PARAM_LIST_OPT",
"PARAM_LIST_OPT_SUIVANT","PARAM_LIST","@17","@18","INIT_OPT_PARAM","CORP_OU_POINT_VIRGULE",
"@19","TYPE","LIST_DEFERENCEMENT","NOM_TYPE","LIST_DECL_IDENTIFIANT","NOUVELLE_VARIABLE_INIT_OPT",
"NOUVELLE_VARIABLE","UNDEF_IDENTIFIANT_OU_NAMESPACE","CONTEXTE_SEMANTIQUE","NOUVEL_IDENTIFIANT_CLASS",
"@20","PATH_IDENTIFIANT_CLASS","@21","PATH_IDENTIFIANT_METHODE","@22", NULL
};
#endif

static const short yyr1[] = {     0,
    42,    43,    42,    45,    46,    44,    44,    47,    44,    44,
    44,    48,    44,    44,    44,    49,    49,    50,    50,    52,
    51,    53,    51,    54,    51,    55,    55,    56,    56,    57,
    58,    57,    59,    59,    61,    60,    60,    62,    60,    63,
    60,    64,    60,    60,    65,    65,    66,    66,    67,    67,
    68,    69,    69,    69,    69,    71,    70,    72,    73,    74,
    72,    75,    75,    76,    76,    78,    79,    77,    80,    80,
    82,    81,    81,    81,    83,    84,    84,    85,    85,    86,
    86,    87,    87,    88,    88,    88,    88,    88,    89,    89,
    90,    90,    91,    92,    91,    93,    94,    93,    95,    95,
    96,    95
};

static const short yyr2[] = {     0,
     1,     0,     2,     0,     0,     8,     2,     0,     4,     2,
     5,     0,     7,     4,     2,     0,     2,     0,     3,     0,
     4,     0,     6,     0,     5,     0,     5,     0,     3,     0,
     0,     3,     0,     1,     0,     4,     2,     0,     4,     0,
     4,     0,     4,     3,     0,     1,     0,     3,     0,     3,
     2,     1,     1,     1,     0,     0,     3,     2,     0,     0,
     7,     0,     1,     0,     2,     0,     0,     6,     1,     0,
     0,     3,     1,     1,     2,     2,     0,     1,     1,     2,
     3,     1,     0,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     0,     4,     1,     0,     4,     1,     1,
     0,     4
};

static const short yydefact[] = {     2,
     1,     0,     0,    91,    96,     0,     0,    30,    78,     0,
     0,     3,     0,     0,    56,    77,     0,    79,    15,    89,
    90,     4,    93,    92,     0,    20,    24,    31,    30,    77,
     0,     0,     8,    34,     7,     0,    77,    75,    97,     0,
    94,    26,    28,    47,    22,     0,     0,     0,     0,    84,
    88,    87,    86,    85,    57,     0,    83,     0,     0,    76,
     0,     0,     0,    55,    21,     0,     0,    16,    32,    28,
     0,    14,     0,     9,    58,     0,    82,    80,   101,    59,
    98,     0,    95,    52,    54,    53,    49,     0,     0,     0,
     0,     0,     0,     0,     0,    46,     0,     0,    18,    25,
    16,    12,    11,    84,    88,    87,    86,    81,     0,    62,
     5,    55,    48,    51,     0,     0,    38,    42,    40,    35,
    29,    37,     0,    17,    23,     0,    99,   100,   102,     0,
    63,    66,     0,    49,    16,    44,     0,     0,     0,     0,
    18,    13,    60,     0,     6,    50,    27,    39,    43,    41,
    36,    19,     0,    70,    74,    71,    73,    61,    69,    67,
     0,    64,    72,     0,    68,    65,     0,     0,     0
};

static const short yydefgoto[] = {   167,
     2,    34,    40,   133,    49,   126,   100,   124,    13,    42,
    70,    43,    65,    68,    27,    44,    35,    96,   140,   137,
   139,   138,    97,    66,   113,    87,    88,    14,    36,    55,
   110,   153,   130,   165,   131,   144,   162,   160,   158,   161,
    15,    38,    16,    56,    78,    57,    22,    17,    28,    63,
    18,    61,    59,   109
};

static const short yypact[] = {    11,
-32768,   146,   -13,-32768,    12,    40,    29,    29,-32768,     7,
     4,-32768,    15,    96,-32768,     5,    38,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    39,-32768,-32768,-32768,    29,     5,
    50,   146,-32768,-32768,-32768,    59,     5,-32768,-32768,    23,
-32768,   -22,    26,    20,-32768,    65,    35,    45,    96,    34,
    60,    12,    42,-32768,-32768,    -7,    33,    67,    46,-32768,
    43,   146,    29,    24,-32768,    61,   116,    79,-32768,    26,
    63,-32768,   146,-32768,-32768,   104,-32768,-32768,-32768,-32768,
-32768,    66,-32768,-32768,-32768,-32768,    77,    43,   116,    64,
    58,    81,    82,    92,    85,-32768,    89,   116,    80,-32768,
    79,-32768,-32768,-32768,-32768,-32768,-32768,    93,   154,    14,
-32768,    24,-32768,-32768,    91,   135,-32768,-32768,-32768,-32768,
-32768,-32768,   133,-32768,-32768,   146,-32768,-32768,-32768,    99,
-32768,-32768,    96,    77,    79,-32768,   116,   116,   116,   116,
    80,-32768,-32768,   104,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   -12,   102,-32768,-32768,-32768,-32768,-32768,-32768,
   105,   107,-32768,    14,-32768,-32768,   148,   149,-32768
};

static const short yypgoto[] = {-32768,
-32768,    -2,-32768,-32768,-32768,-32768,   -92,    21,   -62,-32768,
-32768,-32768,-32768,    98,   134,-32768,   -48,-32768,-32768,-32768,
-32768,-32768,   -47,   122,    36,    62,-32768,   -51,-32768,-32768,
-32768,-32768,-32768,-32768,     8,-32768,-32768,-32768,-32768,-32768,
  -103,   -20,-32768,    95,-32768,    31,-32768,    -5,    -1,-32768,
    -6,-32768,    68,-32768
};


#define	YYLAST		178


static const short yytable[] = {    12,
    74,    25,    25,    31,    95,    26,   132,   155,   125,    46,
   -47,     4,     5,     1,    64,    98,    60,    29,     4,     5,
   156,    19,   157,    25,    30,   -92,    95,    75,    76,    48,
    58,     9,    23,     4,    24,    95,    32,    98,    84,    85,
    86,   115,   147,    20,    21,    37,    98,     4,     5,    33,
   122,    39,    41,    47,    81,    62,    64,    25,    67,    82,
   132,    83,    50,    51,    52,    53,    54,   136,    71,    72,
   103,   -99,    77,   -91,    95,    95,    95,    95,    73,  -100,
    79,   114,    99,    80,   145,    98,    98,    98,    98,   148,
   149,   150,   151,    89,   117,   -33,     3,   102,   116,   111,
     4,     5,    29,    58,     6,     7,     8,   104,   105,   106,
   107,    54,   112,     9,    10,   123,    90,   118,   119,   120,
     4,     5,   121,   142,   135,     7,     8,    11,    76,   -33,
    91,    92,    93,     9,    94,     3,   141,   143,   163,     4,
     5,   159,   164,     6,     7,     8,     3,   168,   169,   -45,
     4,     5,     9,    10,     6,     7,     8,   127,     4,    24,
   128,   152,    45,     9,    10,    69,    11,   101,   -33,   146,
   108,   166,     0,   134,   154,     0,   129,    11
};

static const short yycheck[] = {     2,
    49,     7,     8,    10,    67,     7,   110,    20,   101,    30,
    33,     5,     6,     3,    37,    67,    37,    11,     5,     6,
    33,    35,    35,    29,    18,    14,    89,    35,    36,    32,
    36,    18,     4,     5,     6,    98,    33,    89,    15,    16,
    17,    89,   135,     4,     5,    41,    98,     5,     6,    35,
    98,    14,    14,     4,    61,    33,    37,    63,    33,    62,
   164,    63,     4,     5,     6,     7,     8,   116,     4,    35,
    73,    38,    40,    14,   137,   138,   139,   140,    34,    38,
    14,    88,     4,    38,   133,   137,   138,   139,   140,   137,
   138,   139,   140,    33,    37,     0,     1,    35,    35,    34,
     5,     6,    11,   109,     9,    10,    11,     4,     5,     6,
     7,     8,    36,    18,    19,    36,     1,    37,    37,    35,
     5,     6,    34,   126,    34,    10,    11,    32,    36,    34,
    15,    16,    17,    18,    19,     1,     4,    39,    34,     5,
     6,    40,    36,     9,    10,    11,     1,     0,     0,    34,
     5,     6,    18,    19,     9,    10,    11,     4,     5,     6,
     7,   141,    29,    18,    19,    44,    32,    70,    34,   134,
    76,   164,    -1,   112,   144,    -1,   109,    32
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 127 "parsersyncpp.y"
{
					;
    break;}
case 2:
#line 129 "parsersyncpp.y"
{
			  cout << "CPPFILE -> CORP_DECLARATIF" << endl;
			;
    break;}
case 3:
#line 133 "parsersyncpp.y"
{
					AfficheurArbreSyntaxique vns;
					pileCS.top()->accepterVNS(&vns);
				;
    break;}
case 4:
#line 141 "parsersyncpp.y"
{
		pileCS.push(yyvsp[0].nsp);
		;
    break;}
case 5:
#line 145 "parsersyncpp.y"
{
		// Retour au pere.
		pileCS.pop();
		;
    break;}
case 7:
#line 150 "parsersyncpp.y"
{;
    break;}
case 8:
#line 152 "parsersyncpp.y"
{
		// Retour au pere.
		pileCS.pop();
		;
    break;}
case 10:
#line 158 "parsersyncpp.y"
{;
    break;}
case 12:
#line 161 "parsersyncpp.y"
{
		NoeudSyntaxique *ns;
		ns = new NoeudSyntaxique(pileCS.top(),string(yyvsp[-1].identifiant.text,yyvsp[-1].identifiant.taille),UNDEF_IDENTIFIANT);
		ns->setType(KW_type);
		pileCS.top()->ajouterNS(ns);
		;
    break;}
case 14:
#line 169 "parsersyncpp.y"
{
		yyvsp[-2].nsc->ajouterAlias(string(yyvsp[-1].identifiant.text,yyvsp[-1].identifiant.taille));
		;
    break;}
case 15:
#line 173 "parsersyncpp.y"
{
			printf("CORP_DECLARATIF -> error\n");
			;
    break;}
case 17:
#line 180 "parsersyncpp.y"
{
		pileCS.top()->ajouterAlias(string(yyvsp[-1].identifiant.text,yyvsp[-1].identifiant.taille));
		;
    break;}
case 19:
#line 187 "parsersyncpp.y"
{
		pileCS.top()->ajouterAlias(string(yyvsp[-1].identifiant.text,yyvsp[-1].identifiant.taille));
		;
    break;}
case 20:
#line 194 "parsersyncpp.y"
{
			pileCS.push(yyvsp[0].nsc);
			;
    break;}
case 22:
#line 199 "parsersyncpp.y"
{
		((NsClasse *)pileCS.top())->setVisibilite(DF_PUBLIC);
		;
    break;}
case 24:
#line 204 "parsersyncpp.y"
{
		((NsClasse *)pileCS.top())->setVisibilite(DF_PUBLIC);
		;
    break;}
case 30:
#line 220 "parsersyncpp.y"
{
		pileCS.push(new NsClasse(pileCS.top(),string(""),IDENTIFIANT_CLASS));
		;
    break;}
case 31:
#line 224 "parsersyncpp.y"
{
		pileCS.push(yyvsp[0].nsc);
		;
    break;}
case 34:
#line 232 "parsersyncpp.y"
{/* Nouvelle entre dans le corp dclaratif */;
    break;}
case 35:
#line 238 "parsersyncpp.y"
{
		// Retour au pere.
		pileCS.pop();
		;
    break;}
case 38:
#line 244 "parsersyncpp.y"
{
		NsClasse *nsc = (NsClasse *)pileCS.top();
		nsc->setVisibilite(DF_PUBLIC);		
		;
    break;}
case 40:
#line 249 "parsersyncpp.y"
{
		NsClasse *nsc = (NsClasse *)pileCS.top();
		nsc->setVisibilite(DF_PROTECTED);				
		;
    break;}
case 42:
#line 254 "parsersyncpp.y"
{
		NsClasse *nsc = (NsClasse *)pileCS.top();
		nsc->setVisibilite(DF_PRIVATE);						
		;
    break;}
case 44:
#line 260 "parsersyncpp.y"
{
		printf("CORP_DECLARATIF_CLASS -> error\n");
		;
    break;}
case 47:
#line 269 "parsersyncpp.y"
{
		;
    break;}
case 48:
#line 271 "parsersyncpp.y"
{
		;
    break;}
case 49:
#line 276 "parsersyncpp.y"
{
		;
    break;}
case 50:
#line 278 "parsersyncpp.y"
{
		;
    break;}
case 51:
#line 283 "parsersyncpp.y"
{
			((NsClasse *)pileCS.top())->ajouterClasseMere((NsClasse *)yyvsp[0].nsc,yyvsp[-1].val);
		;
    break;}
case 52:
#line 288 "parsersyncpp.y"
{yyval.val = DF_PUBLIC;;
    break;}
case 53:
#line 289 "parsersyncpp.y"
{yyval.val = DF_PROTECTED;;
    break;}
case 54:
#line 290 "parsersyncpp.y"
{yyval.val = DF_PRIVATE;;
    break;}
case 55:
#line 291 "parsersyncpp.y"
{yyval.val = DF_PRIVATE;;
    break;}
case 56:
#line 298 "parsersyncpp.y"
{
		cout << "Le type:" << yyvsp[0].type->getNomType() << endl;
		pileCS.push(new CsType(pileCS.top(),*yyvsp[0].type));
		;
    break;}
case 57:
#line 303 "parsersyncpp.y"
{
		pileCS.pop();
		;
    break;}
case 59:
#line 310 "parsersyncpp.y"
{
		cout << "C'est une methode " << yyvsp[-1].nsm->getNom() << endl;
		pileCS.top()->ajouterNS(yyvsp[-1].nsm);
		pileCS.push(yyvsp[-1].nsm);
		pileCS.push(new ContexteSemantique(pileCS.top(),string("ListParametre"),-1));
		;
    break;}
case 60:
#line 317 "parsersyncpp.y"
{
		ContexteSemantique *cs;
		AfficheurArbreSyntaxique aas;
		cs = pileCS.top();
		pileCS.pop();
		((NsMethode *)pileCS.top())->ajouterParametre(cs);
		delete cs;
		;
    break;}
case 61:
#line 326 "parsersyncpp.y"
{
		pileCS.pop();
		cout << "Fin de traitement de la methode" << endl;
		;
    break;}
case 66:
#line 344 "parsersyncpp.y"
{
		pileCS.push(new CsType(pileCS.top(),*yyvsp[0].type));
		;
    break;}
case 67:
#line 348 "parsersyncpp.y"
{
		pileCS.pop();
		;
    break;}
case 69:
#line 356 "parsersyncpp.y"
{
		cppIgnorerInitParam();
		;
    break;}
case 71:
#line 364 "parsersyncpp.y"
{
		cppIgnorerBrace();
		;
    break;}
case 74:
#line 370 "parsersyncpp.y"
{
		NsMethode *nsm = (NsMethode *)pileCS.top();
		nsm->setAbstract(true);
		;
    break;}
case 75:
#line 377 "parsersyncpp.y"
{
		if(yyvsp[0].val != 0) {
			cout << "nb def:" << yyvsp[0].val << endl;
			yyvsp[-1].type->setDeferencement(yyvsp[0].val);	
			}
		yyval.type = yyvsp[-1].type;
		;
    break;}
case 76:
#line 387 "parsersyncpp.y"
{
		yyval.val = yyvsp[0].val + 1;
		;
    break;}
case 77:
#line 391 "parsersyncpp.y"
{
		yyval.val = 0;
		;
    break;}
case 78:
#line 397 "parsersyncpp.y"
{
		yyval.type = new Type(string(yyvsp[0].identifiant.text,yyvsp[0].identifiant.taille));
		cout << "Le type est " << string(yyvsp[0].identifiant.text,yyvsp[0].identifiant.taille) << endl;
		;
    break;}
case 79:
#line 402 "parsersyncpp.y"
{
		yyval.type = new Type(yyvsp[0].nsc);
		cout << "Le type est une classe " << yyvsp[0].nsc->getNomComplet() << endl; 
		;
    break;}
case 82:
#line 415 "parsersyncpp.y"
{cppIgnorerInitVar();;
    break;}
case 84:
#line 421 "parsersyncpp.y"
{
		/* On ajoute cette identifiant  la liste */
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),string(yyvsp[0].identifiant.text,yyvsp[0].identifiant.taille),IDENTIFIANT_ATTRIBUT));
		cout << "Ajout d'une variable." << endl;
		;
    break;}
case 85:
#line 427 "parsersyncpp.y"
{
		cout << "Attention(l:" << ligne << "): " << yyvsp[0].ns->getNom() << " est dj utilis dans ce scope pour l'attribut " << yyvsp[0].ns->getNomComplet() << endl;
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),yyvsp[0].ns->getNom(),IDENTIFIANT_ATTRIBUT));
		;
    break;}
case 86:
#line 432 "parsersyncpp.y"
{
		cout << "Attention(l:" << ligne << "): " << yyvsp[0].ns->getNom() << " est dj utilis dans ce scope pour la methode " << yyvsp[0].ns->getNomComplet() << endl;
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),yyvsp[0].ns->getNom(),IDENTIFIANT_ATTRIBUT));
		;
    break;}
case 87:
#line 437 "parsersyncpp.y"
{
		cout << "Attention(l:" << ligne << "): " << yyvsp[0].nsc->getNom() << " est dj utilis dans ce scope pour la classe " << yyvsp[0].nsc->getNomComplet() << endl;
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),yyvsp[0].nsc->getNom(),IDENTIFIANT_ATTRIBUT));
		;
    break;}
case 88:
#line 442 "parsersyncpp.y"
{
		cout << "Attention(l:" << ligne << "): " << yyvsp[0].nsp->getNom() << " est dj utilis dans ce scope pour l'espace de nommage " << yyvsp[0].nsp->getNomComplet() << endl;
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),yyvsp[0].nsp->getNom(),IDENTIFIANT_ATTRIBUT));
		;
    break;}
case 89:
#line 451 "parsersyncpp.y"
{
		yyval.nsp = new NsPaquetage(pileCS.top(),string(yyvsp[0].identifiant.text,yyvsp[0].identifiant.taille),IDENTIFIANT_NAMESPACE);
		pileCS.top()->ajouterNS(yyval.nsp);
		;
    break;}
case 90:
#line 456 "parsersyncpp.y"
{
		yyval.nsp = yyvsp[0].nsp;
		;
    break;}
case 91:
#line 463 "parsersyncpp.y"
{
		yyval.cs = yyvsp[0].nsp;
		;
    break;}
case 92:
#line 467 "parsersyncpp.y"
{
		yyval.cs = yyvsp[0].nsc;
		;
    break;}
case 93:
#line 474 "parsersyncpp.y"
{
		yyval.nsc = new NsClasse(pileCS.top(),string(yyvsp[0].identifiant.text,yyvsp[0].identifiant.taille),IDENTIFIANT_CLASS);
		pileCS.top()->ajouterNS(yyval.nsc);
		;
    break;}
case 94:
#line 479 "parsersyncpp.y"
{
		pileCS.push(yyvsp[-1].cs);
		;
    break;}
case 95:
#line 483 "parsersyncpp.y"
{
		pileCS.pop();
		yyval.nsc = yyvsp[0].nsc;
		;
    break;}
case 96:
#line 491 "parsersyncpp.y"
{
		yyval.nsc = (NsClasse *)yyvsp[0].nsc;
		;
    break;}
case 97:
#line 495 "parsersyncpp.y"
{
		pileCS.push(yyvsp[-1].cs);
		;
    break;}
case 98:
#line 499 "parsersyncpp.y"
{
		pileCS.pop();
		yyval.nsc= yyvsp[0].nsc;
		;
    break;}
case 99:
#line 507 "parsersyncpp.y"
{
		yyval.nsm = new NsMethode(pileCS.top(),string(yyvsp[0].identifiant.text,yyvsp[0].identifiant.taille),IDENTIFIANT_METHODE);
		;
    break;}
case 100:
#line 511 "parsersyncpp.y"
{
		yyval.nsm = (NsMethode *)yyvsp[0].ns;
		;
    break;}
case 101:
#line 515 "parsersyncpp.y"
{
		pileCS.push(yyvsp[-1].cs);
		;
    break;}
case 102:
#line 519 "parsersyncpp.y"
{
		pileCS.pop();
		yyval.nsm = yyvsp[0].nsm;
		;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 524 "parsersyncpp.y"


