#include<parparser.h>

Type::Type(const Type &_t) {
	_ns = _t._ns;
	_ntype = _t._ntype;
	_deferencement = _t._deferencement;
	}
	
Type::Type() {
	_ntype = "";
	_ns = NULL;
	_deferencement = 0;
	}

Type::Type(NoeudSyntaxique *ns) {
	_ns = ns;
	_ntype = ns->getNomComplet();
	_deferencement = 0;
	}
	
Type::Type(const string &ntype) {
	_ntype = ntype;
	_ns = NULL;
	}
				
NoeudSyntaxique *Type::getNs() {
	return _ns;
	}
	
string Type::getNomType() {
	if(_deferencement == 0) {
		return _ntype;
		}
	else
		{
		return _ntype + string('*',_deferencement);	
		}		
	}


int Type::getDeferencement() {
	return _deferencement;
	}
	
void Type::setDeferencement(unsigned int def) {
	_deferencement = def;
	}
