#ifndef VISITEURNOEUDSYNTAXIQUE_H
#define VISITEURNOEUDSYNTAXIQUE_H



class ContexteSemantique;
class NsClasse;
class NsPaquetage;
class NsMethode;
class NsAttribut;

/**
 * Visiteur de l'arbre de syntaxique.
 */

class VisiteurNoeudSyntaxique {
	public:
		virtual void traiterContexteSemantique(ContexteSemantique *cs) 
			{cerr << "traiterContextemSemantique non defini" << endl;}
						
		virtual void traiterNsClasse(NsClasse *nsc)
			{cerr << "traiterNsClasse non defini." << endl;}
			
		virtual void traiterNsPaquetage(NsPaquetage *nsc)
			{cerr << "traiterNsPaquetage non defini." << endl;}
			
		virtual void traiterNsMethode(NsMethode *nsm)
			{cerr << "traiterNsMethode non defini." << endl;}
		
		virtual void traiterNsAttribut(NsAttribut *nsa)
			{cerr << "traiterNsAttribut non defini." << endl;}		
	};
#endif
