/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:43 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:43 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      expheritage.h                            */
/************************************************/

#ifndef EXPHERITAGE_H
#define EXPHERITAGE_H
#include <string>
#include <exprelation.h>

#ifndef NOYCLASSE_H
class Classe;
#endif
#ifndef NOYCOMMUN_H
class Commun;
#endif
#ifndef EXPOBJETFICHIER_H
class ExpObjetFichier;
#endif
#ifndef EXPCLASSE_H
class ExpClasse;
#endif
#ifndef NOYRELATION_H
class Relation;
#endif
#ifndef NOYUTILISATION_H
class Utilisation;
#endif
#ifndef NOYAGREGATION_H
class Agregation;
#endif
#ifndef NOYHERITAGE_H
class Heritage;
#endif
#ifndef NOYASSOCIATION_H
class Association;
#endif
#ifndef EXPDEFINE_H
class ExpDefine;
#endif


/**Cette classe fait les modifications dans la structure pour coder un hritage
 * @author A.Pique
 */
class ExpHeritage : public ExpRelation {


  private:


  public:
 /**Contructeur d'une ExpHeritage
   * \param Heritage * u : Heritage rcupre du noyau
   * \param ExpClasse *c : ExpClasse contenant la relation
   * \param ExpObjetFichier * racine : Correspond  l'instance de classe au sommet de l'export, ce paramtre permet de retrouver la classe ExpClasse correspondant  la classe Classe de destination.
   */
  ExpHeritage(Heritage * h, ExpClasse *c, ExpExport * racine);
    /**Fonction permettant de traiter les changements  faire dans la classe source
   * \param ExpClasse *c : ExpClasse contenant la relation
   * \param Relation * r : Relation rcupre du noyau
   * \param ExpObjetFichier * racine : Correspond  l'instance de classe au sommet de l'export, ce paramtre permet de retrouver la classe ExpClasse correspondant  la classe Classe de destination.
   */
  void traiterSource(ExpClasse *c, Relation * r, ExpExport * racine);
 /**Fonction permettant de traiter les changements  faire dans la classe destination
   * \param ExpClasse *c : ExpClasse contenant la relation
   * \param Relation * r : Relation rcupre du noyau
   * \param ExpObjetFichier * racine : Correspond  l'instance de classe au sommet de l'export, ce paramtre permet de retrouver la classe ExpClasse correspondant  la classe Classe de destination.
   */
  void traiterDestination(ExpClasse *c, Relation * r, ExpExport * racine);

};
#endif
