/************************************************/
/*      A.Pique                                 */
/************************************************/
/*      A.Pique                                 */
/************************************************/
/*     mer fv 13 12:43:45 CET 2002             */
/************************************************/
/*     mer fv 13 12:43:45 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      expinclude.cpp                            */
/************************************************/

#include "expinclude.h"
#include "expclasse.h"


ExpInclude::ExpInclude ( ExpClasse * classeSource, ExpClasse * classeDest, bool heritage ){
  string relPath = "";
  relPath += classeDest->getRelatifPath(classeSource->getRelPath());
  setRelPath(relPath);
  setType(INC_OBLIGATOIRE);
  setNom( classeDest->getNom());
  setHeritage(heritage);
}

ExpInclude::ExpInclude ( const string relPathDest, const string nomDest, bool heritage, int type){
  string relPath = "";
  relPath += relPathDest ; //+ ".h";
  setRelPath(relPath);
  setType(type);
  setNom(nomDest);
  setHeritage(heritage);
}


ExpInclude::~ExpInclude ( ){

}

void ExpInclude::setHeritage ( bool heritage ){
  _heritage = heritage;
}

bool ExpInclude::getHeritage (  ){
  return _heritage;
}

void ExpInclude::setNom ( string nom ){
  _nom = nom;
}

string ExpInclude::getNom (  ){
  return _nom;
}

void ExpInclude::setRelPath ( string relPath ){
  _relPath = relPath;
}

string ExpInclude::getRelPath (  ){
  return _relPath;
}

void ExpInclude::setType ( int type ){
  _type = type;
}

int ExpInclude::getType (  ){
  return _type;
}


string ExpInclude::getPointPath (  ){
  string s = _relPath;
  string::size_type pos = 0;
  pos = s.rfind("./");

  if(pos!=string::npos)
    s = s.erase(0,pos+2);

  pos = s.find("/",0);
  while(pos!=string::npos){
    s.replace(pos,1,".");
    pos = s.find("/",pos);
  }
  return s;
}
