#ifndef COMBOTYPE_H
#define COMBOTYPE_H

#include <qwidget.h>
#include <qcombobox.h>
#include <iostream.h>

/** Cette classe represente la combo box permettant de modifier le type d'une mthode
 * @author F.Duchaussoy, N.Longuet, G.Prevot
 */
class ComboType : public QComboBox
{
	Q_OBJECT

	public:
		/** Constructeur
		 * \param QWidget *parent : Represente le widget parent de ce ComboType (Par defaut 0).
		 * \param const char *name : Represente le nom de ce ComboType (Par defaut 0).
		 */
		ComboType(QWidget *parent=0, const char *name=0);
		//! destructeur 
		virtual ~ComboType() {}
};

#endif

