/************************************************/
/*	Frederic Duchaussoy			*/
/************************************************/
/*	29/01/02				*/
/************************************************/
/*	30/01/02 				*/
/************************************************/
/*	0.1	cration			*/
/************************************************/
/*	Fenetre de creation d'un attribut	*/
/************************************************/

#ifndef FENETREATTRIBUT_H
#define FENETREATTRIBUT_H

#include <qwidget.h>
#include <qlineedit.h>
#include <qcombobox.h>
#include <qmultilineedit.h>

#include <ihmfenetreprincipale.h>
#include <ihmmoncomboclasse.h>
#include <ihmcombotype.h>

#include <noyattribut.h>
/** Cette classe permet de crer*/ 
class FenetreAttribut : public QWidget
{
	Q_OBJECT

	public:
		FenetreAttribut(FenetrePrincipale * fen, Attribut * a=0,
				QWidget *parent=0, const char *name=0);
		virtual ~FenetreAttribut() {};

		QLineEdit *editNom;
		ComboType *comboType;
		QLineEdit *editType;
		QComboBox *comboVisibilite;
		MonComboClasse *comboClasse;
		QMultiLineEdit *editDescription;

		FenetrePrincipale * fenetre;
		Attribut * attribut;
	public slots:
/****************************************/
/*	activation du editType		*/
/****************************************/
		void autre( int index );

/****************************************/
/*	fermeture de la fenetre		*/
/****************************************/
		void annuler();

/****************************************/
/*	Cration de l'attribut		*/
/****************************************/
		void ok();
};

#endif

