#include <iostream.h>

#include <ihmfenetrededessin.h>
#include <ihmfenetreprincipale.h>

FenetreDeDessin::FenetreDeDessin(Noyau * n, QWidget *parent, const char *name)
	: QFrame(parent,name), Observateur()
{
	adjustSize();
	noyau = n ;
	noyau->abonner(this);
	visiteur = new VisiteurDessin(noyau, this);
	conteneur = NULL;
}	

FenetreDeDessin::~FenetreDeDessin()
{
}

Noyau * FenetreDeDessin::getNoyau()
{
	return noyau ;
}

VisiteurDessin * FenetreDeDessin::getVisiteur()
{
	return visiteur;
}

void FenetreDeDessin::setConteneur ( QWidget * w )
{
	conteneur = w;
}

QWidget * FenetreDeDessin::getConteneur ( void )
{
	return conteneur;
}

void FenetreDeDessin::avertir() {
	if (noyau->getProjet() == NULL){
		delete(conteneur);
		conteneur=NULL;
	}
	else {
		if ( ((FenetrePrincipale*)topLevelWidget())->getNoeudCourant() != NULL ) 
			((FenetrePrincipale*)topLevelWidget())->getNoeudCourant()->accepter(visiteur);
		else {
			delete(conteneur);
			conteneur=NULL;
		}
	}
}


