#ifndef FENETREMETHODE_H
#define FENETREMETHODE_H

#include <qwidget.h>
#include <qlineedit.h>
#include <qcombobox.h>
#include <qlistbox.h>
#include <qmultilineedit.h>

#include <ihmcombotype.h>
#include <ihmmoncomboclasse.h>
#include <ihmfenetreprincipale.h>
#include <noymethode.h>

class FenetreMethode : public QWidget
{
	Q_OBJECT

	public:
		FenetreMethode(FenetrePrincipale * fen, Methode * m=0,
				QWidget *parent=0, const char *name=0);
		virtual ~FenetreMethode() {};

		MonComboClasse *comboClasse;
		QComboBox *comboVisibilite;
		ComboType *comboType;
		QLineEdit *editType;
		QLineEdit *editNom;

		QListBox *comboParam;
		ComboType *comboTypeParam;
		QLineEdit *editTypeParam;
		QLineEdit *editParam;
		QMultiLineEdit *editDescription;
	private:
		Methode * methode;
		FenetrePrincipale * fenetre;
		std::vector<Parametre*> vctParametre ;
	public slots:
		void annuler();
		void ok();
		void ajouter();
		void supprimer();
		void autre(int);
		void autreType(int index);
};

#endif

