#include <vector.h>
#include <ihmmoncomboclasse.h>

MonComboClasse::MonComboClasse( Classe * c , FenetrePrincipale * f , QWidget * parent , const char* name ) : QComboBox(parent,name)
{
	/* parcours du vecteur de classe pour ajouter les entres du combobox */
	std::vector<Classe*>::iterator it;
	int indice=0 , i = 0;

	it = f->vctClasse.begin();
	while ( it != f->vctClasse.end() ) {
		this->insertItem( QString( (*it)->getNomComplet().c_str() ) );
		if ( (*it) == c ) indice = i;
		++i;
		++it;
	}
	this->setCurrentItem( indice );
}

MonComboClasse::~MonComboClasse()
{

}

