#include <vector.h>
#include <ihmmoncombovue.h>
#include <ihmfenetreprincipale.h>
#include <qwidget.h>
#include <ihmfenetrecommentaire.h>

MonComboVue::MonComboVue( DiagrammeStatique *dg , QWidget * parent , const char* name ) : QComboBox(parent,name)
{
	/* parcours du vecteur de vues pour ajouter les entres du combobox */
	std::vector<Vue*> vctVue = dg->getVctVue();
	std::vector<Vue*>::iterator it = vctVue.begin();
	int i=0;
	int indice =0;
	QWidget * qw = parent->parentWidget();
	FenetrePrincipale * f = ((FenetreCommentaire *)qw)->fenetre;
	while ( it != vctVue.end() ) {
		this->insertItem( QString( (*it)->getNom().c_str() ) );
		if ((*it) == (f->getNoeudCourant())) indice = i;
		++i;
		++it;
	}
	this->setCurrentItem(indice);
}

MonComboVue::~MonComboVue()
{

}

