#ifndef IHMMONCOMBOVUE_H
#define IHMMONCOMBOVUE_H

#include <qwidget.h>
#include <qcombobox.h>

#include <noydiagrammestatique.h>

/** Cette classe represente un combobox contenant les noms des vues du projet.
 * Ce combobox peut tre positionn sur une vue particulire  la cration.
 * @author F.Duchaussoy, N.Longuet, G.Prevot
 */

class MonComboVue : public QComboBox
{
	public:

		/** Constructeur
		 * \param DiagrammeStatique *dg : Diagramme statique contenant les vues  mettre dans le MonComboVue.
		 * \param FenetrePrincipale *f : Reference sur la fentre principale de l'application.
		 * \param QWidget *parent : Represente le widget parent du MonComboVue (Par defaut 0).
		 * \param const char *name : Represente le nom que l'on veut donner au MonComboVue.
		 */
		MonComboVue( DiagrammeStatique * dg , QWidget * parent=0 , const char *name=0 );

		//! Destructeur
		virtual ~MonComboVue( );
};

#endif

