/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:32 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:32 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyassociation.h                        */
/************************************************/

#ifndef NOYASSOCIATION_H
#define NOYASSOCIATION_H
#include <iostream>
#include <noyrelation.h>

/**
 * Cette classe a pour but de modliser une association au sens UML du terme.
 * @author clucas - ndouay
 */
class Association:public Relation{

public:

	/**Cette methode est le constructeur d'une association
	* \param Noeud *pere : pointeur sur un objet de type noeud representant l'objet pre de l'association
	* \param const string &nom : nom donn  la relation (elle peut ne pas en avoir)
	* \param Classe *source : pointeur sur un objet de type classe designant l'origine de la relation
	* \param Classe *destination : pointeur sur un objet de type classe designant la classe pointe par la relation
	* \param const string &multipliciteSource : chane de caractres reprsentant la multiplicit de la source de la relation
	* \param const string &multipliciteDestination : chane de caractres reprsentant la multiplicit de la destination de la relation
	*/
	Association(Noeud *pere,const string &nom, Classe *source, Classe *destination,const string & multipliciteSource, const string &multipliciteDestination);

	/**Cette mthode est le destructeur d'une association
	*/
	virtual ~Association();
	
	/** Cette mthode permet d'accepter un visiteur implment
	* /param VisiteurRelation *v : visiteur propre au quatre relation uml
	*/
	virtual void accepter(VisiteurNoeud *v);
};
#endif
