/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:32 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:32 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyattribut.cpp                         */
/************************************************/

#include <noyattribut.h>

Attribut::Attribut(Noeud *pere,const string &nom,const string &visible,const string &type)
:Noeud(pere,nom)
{
	setVisible(visible);
	setType(type);
}

Attribut::~Attribut() {}

void Attribut::setVisible(const string &visible)
{
	_visible = visible;
}

void Attribut::setType(const string &type)
{
	_type = type;
}

string Attribut::getVisible()
{
	return _visible;
}

string Attribut::getType()
{
	return _type;
}

string Attribut::petiteChaine()
{
	if (getVisible() == "public") return "+" +getNom();
	if (getVisible() == "protected") return "#" +getNom();
	else return "-" +getNom();
}

string Attribut::grandeChaine()
{
	string retour ;
	if( getVisible() == "public" ) {
		retour = "+" ;
	} else {
		if( getVisible() == "protected" ) {
			retour = "#" ;
		}else{
			retour = "-" ;
		}
	}
	return retour + " " + getType() + " " + getNom();
}

void Attribut::accepter(VisiteurNoeud *v)
{
	v->traiterAttribut(this);
}
