/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:33 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:33 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noycollaboration.h                            */
/************************************************/

#ifndef NOYCOLLABORATION_H
#define NOYCOLLABORATION_H
#include <iostream>
#include <noynoeud.h>
/**Cette classe reprsente les diagrammes de collaborations au sens uml
* Ces diagrammes ne sont pas implment dans la premire version du logiciel
* @author clucas - ndouay
*/
class Collaboration : public Noeud {
public:

	/**Constructeur
	*/
	Collaboration():Noeud(0,"Collaboration"){}
	/**Constructeur
	* \param Noeud* pere : pointeur sur le noeud pre du diagramme de collaboration
	* \param const string &nom : chane de caractres donnant le nom du diagramme statique
	*/
	Collaboration(Noeud* pere,const string &nom);
	
	//! Destructeur
	virtual ~Collaboration();
	
	/**Cette mthode permet d'accepter un visiteur qui va pouvoir parcourir le diagramme statique
	* \param VisiteurNoeud* v : pointeur sur un visiteur
	*/
	virtual void accepter(VisiteurNoeud* v);
};
#endif
