/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:35 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:35 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyelementdemodelisation.h                            */
/************************************************/

#ifndef NOYELEMENTDEMODELISATION_H
#define NOYELEMENTDEMODELISATION_H
#include <iostream>
#include <noynoeud.h>

/**
 * Cette classe a pour but de fournir une base commune
 * aux objets UML au sens du noyau.
 * @author clucas - ndouay
 * @brief Il faut noter que cette classe hrite de noeud.
 */
class ElementDeModelisation:public Noeud{
	
public:
	//! Constructeur
	ElementDeModelisation(Noeud* pere,const string &nom);
	//! Destructeur
	~ElementDeModelisation();
	
	/** Cette mthode permet de rcuprer un pointeur sur le diagramme statique pre de tous les objets UML de premier niveau
	* \return elle retourne un pointeur sur un objet de type DiagrammeStatique
	*/	
	DiagrammeStatique *getDiagrammeStatique();
};
#endif
