/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:38 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:38 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyobjetuml.cpp                         */
/************************************************/

#include <noyobjetuml.h>
#include <noyvisiteurnoeud.h>
#include <noypaquetage.h>
#include <noyclasse.h>
#include <string.h>
#include <iostream>
#include <stdio.h>
#include <noydiagrammestatique.h>

Objetuml::Objetuml(Noeud* pere,const string &nom):ElementDeModelisation(pere, nom) {}

Objetuml::~Objetuml() {}

void Objetuml::accepter(VisiteurNoeud* v)
{
	v->traiterObjetuml(this);
}

class lVisiteur : public VisiteurNoeud {
	public:
		string nc;
		virtual ~lVisiteur(){}
		void traiterPaquetage(Paquetage *p) {
			nc = p->getNomComplet();
		}

		void traiterClasse(Classe *c) {
			nc = c->getNomComplet();
		}

		void traiterDiagrammeStatique(DiagrammeStatique *dg) {
			nc = "";
		}
};

string Objetuml::getNomComplet()
{
	lVisiteur lv;
	getPere()->accepter(&lv);
	if(lv.nc == string("")) {
		return getNom();
		}
	else	{
		string s;
		s = lv.nc;
		s += string("::");
		s += getNom();
		return s;
		}
}

void	Objetuml::deplacerVersDiagrammeStatique( Noeud *n )
{
	DiagrammeStatique	*d;
	d = getDiagrammeStatique( );

	// si c'est diffrent c'est que je suis dans un paquetage
	if( d != getPere() ) {
		d->ajouterObjetuml( this );
		( (Paquetage *)getPere())->enleverObjetuml( this );
		this->setPere( d );
	}
}

void	Objetuml::deplacerVersPaquetage( Paquetage *p )
{
	DiagrammeStatique	*d;
	d = getDiagrammeStatique( );

	if (p != this){
		if( d == getPere() ) {
			// je suis dans le DiagrammeStatique (le noeud)
			this->setPere( p );
			p->ajouterObjetuml( this );
			d->enleverObjetuml( this );
		} else {
			if( getPere() != p ) {
				p->ajouterObjetuml( this );
				( (Paquetage *)getPere()) ->enleverObjetuml( this );
				this->setPere( p );
			}
		}
	}
}

class VisiteurNom : public VisiteurNoeud {
	public:
		std::vector<Objetuml *>::iterator it;
		std::vector<Objetuml *> v;
		bool ouioui ;
		int nbOccurence;
		string nom;
		string s;
		unsigned int i,j;
		
		VisiteurNom(const string &n){
			nom = n;
			nbOccurence =0;
		}
		
		virtual ~VisiteurNom(){}
		
		void traiterPaquetage(Paquetage *p) {
			ouioui = false ;
			v = p->getVctObjetuml();
			it = v.begin();
			while(it != v.end()) {
				s = (*it)->getNom();
				if (s.find(nom) != string::npos){
					i=0;j=0;
					while ((i < s.size()) && (j < nom.size()) && (s[i] == s[j])){
						++i;
						++j;
					}
					if ((i == s.size()) && (j == nom.size())){
						ouioui = true;
						++nbOccurence;
						//Noeud::setNom("copie de " + nom);
						nom = "copie de "+nom;
						//break;
					}
				}
				++it;
			}
		//	if (it == v.end()){nom = nom;}
		}

		void traiterDiagrammeStatique(DiagrammeStatique *dg) {
			ouioui = false ;
			
			v = dg->getVctObjetuml();
			it = v.begin();
			while(it != v.end()) {
				s = (*it)->getNom();
				if (s.find(nom) != string::npos){
					i=0;j=0;
					while ((i < s.size()) && (j < nom.size()) && (s[i] == s[j])){
						++i;
						++j;
					}
					if ((i == s.size()) && (j == nom.size())){
						ouioui = true;
						++nbOccurence;
						//nom = "copie de " + nom;
						//Noeud::setNom("copie de " + nom);
						//break;
					}
				}
				++it;
			}
			//if (it == v.end()){nom = nom;/*Noeud::setNom(nom);*/}
			cout << "dans visiteur" + nom <<endl;
		}
};

bool Objetuml::setNom(const string &nom)
{
	VisiteurNom *vn = new VisiteurNom(nom);

	getPere()->accepter( vn );
	/*if(vn->nbOccurence > 1 ) {
		//sprintf(s,"%d",vn->nbOccurence -1);
 		//if ((vn->getnom()).find("copie") == 1){
		//	nb = vn->nbOccurence +1;	
		//}
		//else
		//setNom("copie de " + nom);
		return false;
	} else {*/
		if ((vn->ouioui == true) && (vn->nbOccurence >1)){
			Noeud::setNom("copie de "+ nom);
			return false;
		}
		else{
			cout << "dans setNom : " +nom << endl;
			Noeud::setNom(nom);
		}
		return true;
	/*}	return true;*/	
}
