/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:40 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:40 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyparametre.h                            */
/************************************************/

#ifndef NOYPARAMETRE_H
#define NOYPARAMETRE_H
#include <iostream>
#include <string> 

/**Cette classe est implmente afin de pouvoir reprsenter les paramtres des fonctions
* @author clucas - ndouay
*/
class Parametre{
	
	private:
		//! type du paramtre
		string _type;
		//! nom du paramtre
		string _nom;
	public:
	
		/**Constructeur d'un paramtre
		*/
		Parametre();

		/** Un autre constructeur 
		 */
		Parametre( const string& nom , const string& type );
		
		/**Destructeur d'un paramtre
		*/
		virtual ~Parametre();
		
		/**Cette fonction permet de recuprer le nom d'un paramtre
		* \return elle retourne le nom du paramtre cherch dans un type "string"
		*/
		string getNom();
		
		/**Cette fonction permet de recuprer le type d'un paramtre
		* \return elle retourne le type du paramtre cherch dans un type "string"
		*/
		string getType();
		
		/**Cette fonction permet de fixer le nom d'un paramtre d'une fonction
		* \param string Nom : nom du paramtre donn par l'utilisateur au parmtre
		*/
		void setNom(const string &Nom);
		
		/**Cette fonction permet de fixer le type d'un paramtre d'une fonction
		* \param string type : type du paramtre donn par l'utilisateur au parmtre
		*/
		void setType(const string &type);
};
#endif
