/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:40 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:40 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyprojet.cpp                           */
/************************************************/

#include <noyprojet.h>

Projet::Projet(const string &nom , Noyau *n ,bool b1=true, bool b2=false, bool b3=false, bool b4=true, bool b5=true, bool b6=false):Noeud(0,nom){
	_n = n ;
	setLangage(b1);
	setAjouter(b2);
	setEdition(b3);
	setPro(b4);
	setNomLong(b5);
	setAccesseur(b6);
}

Projet::~Projet() {}

void Projet::accepter(VisiteurNoeud* v) {v->traiterProjet(this);}

DiagrammeStatique* Projet::getDiagrammeStatique( void )
{
	return &d;
}

UseCase* Projet::getUseCase()
{
	return &u;
}

Collaboration* Projet::getCollaboration()
{
	return &c;
}

string Projet::getVersion() {return _version;}

void Projet::setVersion(const string &version) { _version = version;}
	
string Projet::getAuteur() {return _auteur;}

void Projet::setAuteur(const string &auteur) { _auteur = auteur;}
	
string Projet::getCommentaire() {return _commentaire;}

void Projet::setCommentaire(const string &commentaire) { _commentaire = commentaire;}

bool Projet::getLangage() { return _langage;}

bool Projet::getAjouter() { return _boolaj;}

bool Projet::getEdition() { return _booled;}
	
bool Projet::getPro() { return _boolpro;}

bool Projet::getNomLong() { return _boolnom; }

bool Projet::getAccesseur() { return _boolacc; }

void Projet::setLangage(bool b) { _langage = b; }

void Projet::setAjouter(bool b){ _boolaj = b; }

void Projet::setEdition(bool b){ _booled = b; }

void Projet::setPro(bool b){ _boolpro = b; }

void Projet::setNomLong(bool b){ _boolnom = b; }

void Projet::setAccesseur(bool b){ _boolacc = b; }
