/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 13:36:41 CET 2002             */
/************************************************/
/*     mer fv 13 13:36:41 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noyrelation.cpp                         */
/************************************************/

#include <noyrelation.h>
#include <noyclasse.h>
#include <noyvue.h>
#include <noydiagrammestatique.h>

Relation::Relation(Noeud* pere,const string &nom) : ElementDeModelisation(pere,nom) {}

Relation::Relation(Noeud *pere , const string &nom , Classe *source, Classe *destination,const string & multipliciteSource, const string &multipliciteDestination, bool doubleFleche = true) 
: ElementDeModelisation(pere,nom)
{
	_clSource = source ;
	_clDestination = destination ;
	_multipliciteSource = multipliciteSource;
	_multipliciteDestination = multipliciteDestination;
	_doubleFleche = doubleFleche;
}


Relation::~Relation() 
{
	Classe *dest,*source;
	std::vector<Relation *> vctRel;
	DiagrammeStatique *d;
	
	
	dest = getClasseDestination();
	source = getClasseSource();
	
	// dans les vues
	d = getDiagrammeStatique();
	if( d == NULL ) { cout << "pb !!! je quitte !" << endl; exit(23); }
	// Pour chaque vue, je regarde si j'existe dans celle-ci!
	std::vector<Vue*>::iterator it2;
	std::vector<Vue*> v ;
	v = d->getVctVue();
	if( v.size() != 0 ) {
		it2 = v.begin();
		while( it2 != v.end() ){
			(*it2)->supprimerRelation( this );
			++it2;
		}
	}
}

void Relation::accepter(VisiteurNoeud* v)
{
	v->traiterRelation(this);
}

void Relation::setClasseDestination( Classe *destination )
{
	_clDestination = destination;
}

Classe* Relation::getClasseDestination( )
{
	return _clDestination ;
}

void Relation::setClasseSource(Classe *source)
{
	_clSource = source;
}

Classe* Relation::getClasseSource()
{
	return _clSource;
}

void	Relation::setMultipliciteSource( string multipliciteSource )
{
	_multipliciteSource = multipliciteSource;
}

void	Relation::setMultipliciteDestination( string multipliciteDestination )
{
	_multipliciteDestination = multipliciteDestination;
}

void	Relation::setDoubleFleche( bool doubleFleche )
{
	_doubleFleche = doubleFleche;
}

string	Relation::getMultipliciteSource( )
{
	return _multipliciteSource;
}
string	Relation::getMultipliciteDestination( )
{
	return _multipliciteDestination;
}

bool	Relation::getDoubleFleche( )
{
	return _doubleFleche;
}
