/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*      N.Douay - C.Lucas                       */
/************************************************/
/*     mer fv 13 12:18:05 CET 2002             */
/************************************************/
/*     mer fv 13 12:18:05 CET 2002             */
/************************************************/
/*      Numero de version et commentaire        */
/*      0.1     Cration                        */
/************************************************/
/*      noystockage.h                           */
/************************************************/

#ifndef NOYSTOCKAGE_H
#define NOYSTOCKAGE_H

#include <iostream>
#include <string>
#include <fstream>

#include <noyvisiteurnoeud.h>
//#include <noynoyau.h>
class Noyau;
/** Cette classe sert  sauver et  charger le modle en mmoire
* @author clucas-ndouay
*/
class Stockage{

private:
	Noyau *noy;
	
public:
	//! flux de sortie
	ofstream sortie;
	//! flux d'entre
	ifstream entree;
	
	//! Constructeur
	Stockage(Noyau *n);
	//! Destructeur
	virtual ~Stockage();
	
	virtual void accepter(VisiteurNoeud *v);
	
	/** Cette mthode permet de lancer le chargement du fichier
	* \param const string &path : nom du fichier de sauvegarde
	*/
	bool sauver(const string &path);
	
	/** Cette mthode permet de lancer le chargement d'un fichier
	* \param const string &path : nom du fichier  charger
	*/ 
	bool charger(const string &path);
};
#endif
