#include<parparser.h>

NsAttribut::NsAttribut(const NsAttribut &nsa)
	: NoeudSyntaxique(nsa)
	{
	_type = nsa._type;
	_attr = NULL;
	}

NsAttribut::NsAttribut(ContexteSemantique *csPere,const string &nom,int type) 
	: NoeudSyntaxique(csPere,nom,type) 
	{
	}
	
NsAttribut::~NsAttribut() {
	}

void NsAttribut::accepterVNS(VisiteurNoeudSyntaxique *v) {
	v->traiterNsAttribut(this);
	}

string NsAttribut::getNomComplet() {
	if(getCsPere() == NULL) {
		return _type.getNomType() + string(" ") + getNom();
		}
	if(getCsPere()->getNomComplet() != "") {
		return _type.getNomType() + string(" ") + getCsPere()->getNomComplet() + string("::") + getNom();
		}
	else {
		return _type.getNomType() + string(" ") + getNom();
		}
	}

void NsAttribut::remplacerNS(NoeudSyntaxique *ns,NoeudSyntaxique *ns2) {
	if(_type.getNs() == ns) _type = Type(ns2);
	}
	
void NsAttribut::setVarType(const Type &t) {	
	_type = t;
	}
	
Type NsAttribut::getVarType() {
	return _type;
	}
	
void NsAttribut::setAttribut(Attribut *attr) {
	_attr = attr;
	}
		
Attribut *NsAttribut::getAttribut() {
	return _attr;
	}
