#include <parparser.h>
#include <stdio.h>

ImportFile::ImportFile(const ImportFile &src) {
			listFileJava = src.listFileJava;
			_FichierCourant = src._FichierCourant;
			_ligneFichierCourant = src._ligneFichierCourant;
			_currentImport = src._currentImport;
			buffer = src.buffer;
			}
			
ImportFile::ImportFile() {buffer = NULL;}
		
ImportFile::~ImportFile() {
			if(buffer != NULL) {
				javaDeleteBuffer(buffer);
				}
			}

void ImportFile::ajouterFichierJava(const string &s) {
	std::vector<string>::iterator it = listeFichier.begin();
	while((it != listeFichier.end()) && (*it != s)) ++it;
		if(it == listeFichier.end()) {
			listeFichier.push_back(s);
			listFileJava.push(s);
			}
		}

void *ImportFile::getBufferCourant() {
	if(buffer == NULL) {
		FILE *file;
		while((listFileJava.size() > 0) && (buffer == NULL)) {
			file = javaOuvrirFichierSource(listFileJava.top());
			if(file != NULL) {
				_FichierCourant = listFileJava.top();
				_ligneFichierCourant = 1;
				_currentImport.resize(0);
				_currentImport.push_back("java.lang");
				pileCS.push(pileCS.top());
				buffer = javaCreateBuffer(file);
				}
			listFileJava.pop();
			}
		}
	
	cout << endl;
	cout << "javaOuvrirFichierSource:" << _FichierCourant << endl;
	ligne = _ligneFichierCourant;
	return buffer;
	}

void ImportFile::detruireBufferCourant() {
	if(buffer != NULL) 
		{
		javaDeleteBuffer(buffer);
		buffer = NULL;
		}
	}

string ImportFile::getFichierCourant() {
	return _FichierCourant; 
	}

void ImportFile::ajouterImport(const string &s) {
	_currentImport.push_back(s);
	}

void ImportFile::getCurrentImport(std::vector<string> &currentImport) {
	currentImport = _currentImport;
	}

unsigned int ImportFile::getLigneFichierCourant() {return _ligneFichierCourant;}

void ImportFile::setLigneFichierCourant(unsigned int l) {_ligneFichierCourant = l;}


