
/*  A Bison parser, made from parsersynjava.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse javaparse
#define yylex javalex
#define yyerror javaerror
#define yylval javalval
#define yychar javachar
#define yydebug javadebug
#define yynerrs javanerrs
#define	END_OF_FILE	257
#define	IDENTIFIANT_NONDEF	258
#define	IDENTIFIANT_PAQUETAGE	259
#define	IDENTIFIANT_CLASS	260
#define	IDENTIFIANT_METHODE	261
#define	IDENTIFIANT_ATTRIBUT	262
#define	KW_package	263
#define	KW_import	264
#define	KW_class	265
#define	KW_abstract	266
#define	KW_final	267
#define	KW_implements	268
#define	KW_extends	269
#define	KW_interface	270
#define	KW_tableau	271
#define	KW_public	272
#define	KW_private	273
#define	KW_protected	274
#define	KW_type	275

#line 1 "parsersynjava.y"

#include <iostream>
#include <stdio.h>
#include <stdlib.h>

#include <parparser.h>


//#define YYDEBUG 1

NsPaquetage *nspMisc;

ContexteSemantique *javaRacine;

void javaerror (char *s)
	{
	string sLigne;
	char cpLigne[15];
	istream in;
	cerr << "JAVAERROR:" << s << "  la ligne " << ligne << " dans le fichier " << pileImport.top().getFichierCourant() << endl;
	snprintf(cpLigne,15,"%d",ligne);
	erreur.text = string(s) + string("  la ligne ") + string(cpLigne) ;
	}

extern int javalex();
extern FILE *javain;

NoeudSyntaxique *trouverNoeudSyntaxique(string lieu,const string &sRecherche) {
			unsigned int id;
			NoeudSyntaxique *ns = pileCS.top();
			string s;
			id =0;
			while(id < lieu.size()) {
				while((id < lieu.size()) && (lieu[id] != '.')) id++;
				s = string(lieu.c_str(),id);
				ns = ns->possedeNS(s);
				
				if(ns == NULL) {
						return NULL;
						}
				if(id < lieu.size()) {
					s = string(lieu,id + 1);
					lieu = s;
					id = 0;	
					}
				}
			return ns->possedeNS(sRecherche);
			}



class AfficheurArbreSyntaxiqueJava : public VisiteurNoeudSyntaxique {
	private:
		NoeudSyntaxique *trouverNoeudSyntaxique(string lieu,const string &sRecherche) {
			unsigned int id;
			NoeudSyntaxique *ns = pileCS.top();
			string s;
			id =0;
			while(id < lieu.size()) {
				while((id < lieu.size()) && (lieu[id] != '.')) id++;
				s = string(lieu.c_str(),id);
				ns = ns->possedeNS(s);
				
				if(ns == NULL) {
						return NULL;
						}
				if(id < lieu.size()) {
					s = string(lieu,id + 1);
					lieu = s;
					id = 0;	
					}
				}
			return ns->possedeNS(sRecherche);
			}
	public:
		virtual void traiterContexteSemantique(ContexteSemantique *cs) 
			{
				cout << "cs:" << cs->getNomComplet() << endl;
				cs->visiterNS(this);
			}
						
		virtual void traiterNsClasse(NsClasse *nsc)
			{
				cout << "nscjava:" << nsc->getNomComplet() << endl;
				nsc->visiterNS(this);
			}
			
		virtual void traiterNsPaquetage(NsPaquetage *nsp)
			{
				nsp->visiterNS(this);
			}
			
		virtual void traiterNsMethode(NsMethode *nsm)
			{
			}
		
		virtual void traiterNsAttribut(NsAttribut *nsa)
			{
			}
	};


#line 104 "parsersynjava.y"
typedef union {
	ContexteSemantique *cs;
	NsClasse *nsc;
	NsPaquetage *nsp;
	NsMethode *nsm;
	NsAttribut *nsa;
	NoeudSyntaxique *ns;
	Type *type;
	Chaine identifiant;
	void *contexte;
	unsigned int val;
	} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		149
#define	YYFLAG		-32768
#define	YYNTBASE	30

#define YYTRANSLATE(x) ((unsigned)(x) <= 275 ? yytranslate[x] : 78)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    25,
    26,     2,     2,    27,     2,    29,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    22,     2,
    28,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    23,     2,    24,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     3,     6,     8,    10,    11,    13,    14,    15,
    29,    30,    31,    43,    44,    50,    51,    52,    53,    67,
    68,    69,    81,    84,    85,    86,    91,    94,    95,    96,
   105,   106,   107,   114,   115,   117,   118,   121,   122,   123,
   130,   132,   133,   134,   138,   140,   142,   144,   146,   148,
   150,   153,   157,   159,   160,   163,   166,   169,   172,   175,
   178,   181,   184,   185,   187,   189,   191,   192,   195,   196,
   199,   200,   203,   204,   206,   210,   212,   214,   215,   220,
   221,   226,   228,   229,   234,   236,   238,   240
};

static const short yyrhs[] = {     3,
     0,     0,    31,    34,     0,     6,     0,     4,     0,     0,
    22,     0,     0,     0,    66,    77,    11,    32,    35,    68,
    69,    23,    40,    24,    33,    36,    34,     0,     0,     0,
    66,    16,    32,    37,    67,    23,    40,    24,    33,    38,
    34,     0,     0,     9,    74,    22,    39,    34,     0,     0,
     0,     0,    66,    77,    11,    32,    41,    68,    69,    23,
    40,    24,    33,    42,    40,     0,     0,     0,    66,    16,
    32,    43,    67,    23,    40,    24,    33,    44,    40,     0,
    45,    40,     0,     0,     0,    66,    64,    46,    47,     0,
    61,    22,     0,     0,     0,    60,    25,    48,    52,    26,
    65,    49,    58,     0,     0,     0,    25,    50,    52,    26,
    51,    58,     0,     0,    54,     0,     0,    27,    54,     0,
     0,     0,    64,    55,    63,    57,    56,    53,     0,    28,
     0,     0,     0,    23,    59,    24,     0,    22,     0,     4,
     0,     7,     0,     6,     0,     5,     0,     8,     0,    63,
    62,     0,    61,    27,    61,     0,    28,     0,     0,     4,
    65,     0,     8,    65,     0,     7,    65,     0,     6,    65,
     0,     5,    65,     0,    21,    65,     0,    71,    65,     0,
    17,    65,     0,     0,    18,     0,    20,     0,    19,     0,
     0,    15,    70,     0,     0,    15,    71,     0,     0,    14,
    70,     0,     0,    71,     0,    70,    27,    70,     0,     6,
     0,     4,     0,     0,    76,    29,    72,    71,     0,     0,
     6,    29,    73,    71,     0,    76,     0,     0,    76,    75,
    29,    74,     0,     4,     0,     5,     0,    12,     0,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   153,   154,   163,   202,   206,   214,   215,   218,   224,   229,
   229,   235,   240,   240,   264,   264,   267,   274,   279,   279,
   285,   290,   290,   291,   294,   301,   306,   307,   312,   321,
   325,   334,   343,   353,   355,   358,   360,   363,   368,   373,
   375,   380,   383,   389,   389,   396,   401,   405,   409,   413,
   422,   424,   427,   430,   436,   442,   446,   450,   454,   460,
   464,   470,   471,   475,   476,   477,   478,   482,   483,   486,
   492,   495,   496,   499,   505,   508,   513,   520,   526,   532,
   538,   547,   551,   555,   563,   570,   576,   577
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","END_OF_FILE",
"IDENTIFIANT_NONDEF","IDENTIFIANT_PAQUETAGE","IDENTIFIANT_CLASS","IDENTIFIANT_METHODE",
"IDENTIFIANT_ATTRIBUT","KW_package","KW_import","KW_class","KW_abstract","KW_final",
"KW_implements","KW_extends","KW_interface","KW_tableau","KW_public","KW_private",
"KW_protected","KW_type","';'","'{'","'}'","'('","')'","','","'='","'.'","JAVAFILE",
"@1","DEC_CLASS","OPT_PT_VIRGULE","CORP_DECLARATIF","@2","@3","@4","@5","@6",
"CORP_DECLARATIF_CLASS","@7","@8","@9","@10","PREC_DECLARATION","@11","DECL_METHODE_OU_VARIABLE",
"@12","@13","@14","@15","PARAM_LIST_OPT","PARAM_LIST_OPT_SUIVANT","PARAM_LIST",
"@16","@17","INIT_OPT_PARAM","CORP_OU_POINT_VIRGULE","@18","NOUVEL_IDENTIFIANT_METHODE",
"LIST_DECL_IDENTIFIANT","NOUVELLE_VARIABLE_INIT_OPT","NOUVELLE_VARIABLE","TYPE",
"OPT_TABLEAU","VISIBILITE_OPT","HERITE_DE_INTERFACE","HERITE_DE","IMPLEMENTE",
"LISTE_NOM_LONG_CLASSE_MERE","NOM_LONG_CLASSE_MERE","@19","@20","PATH_PAQUETAGE",
"@21","PAQUETAGE","ABSTRACT_OPT", NULL
};
#endif

static const short yyr1[] = {     0,
    30,    31,    30,    32,    32,    33,    33,    35,    36,    34,
    37,    38,    34,    39,    34,    34,    41,    42,    40,    43,
    44,    40,    40,    40,    46,    45,    47,    48,    49,    47,
    50,    51,    47,    52,    52,    53,    53,    55,    56,    54,
    57,    57,    59,    58,    58,    60,    60,    60,    60,    60,
    61,    61,    62,    62,    63,    63,    63,    63,    63,    64,
    64,    65,    65,    66,    66,    66,    66,    67,    67,    68,
    68,    69,    69,    70,    70,    71,    71,    72,    71,    73,
    71,    74,    75,    74,    76,    76,    77,    77
};

static const short yyr2[] = {     0,
     1,     0,     2,     1,     1,     0,     1,     0,     0,    13,
     0,     0,    11,     0,     5,     0,     0,     0,    13,     0,
     0,    11,     2,     0,     0,     4,     2,     0,     0,     8,
     0,     0,     6,     0,     1,     0,     2,     0,     0,     6,
     1,     0,     0,     3,     1,     1,     1,     1,     1,     1,
     2,     3,     1,     0,     2,     2,     2,     2,     2,     2,
     2,     2,     0,     1,     1,     1,     0,     2,     0,     2,
     0,     2,     0,     1,     3,     1,     1,     0,     4,     0,
     4,     1,     0,     4,     1,     1,     1,     0
};

static const short yydefact[] = {     2,
     1,    67,     0,    64,    66,    65,     3,    88,    85,    86,
     0,    82,    87,     0,     0,    14,     0,     5,     4,    11,
     0,    67,     0,    69,     8,    15,    84,     0,     0,    71,
    77,    76,    68,    74,     0,    67,     0,    73,    80,     0,
    78,     0,    67,    88,    70,     0,     0,     0,    75,     0,
     6,    23,     0,    63,    25,    63,     0,    72,    67,    81,
    79,     7,    12,    20,    63,    60,     0,    61,     0,     0,
    67,    69,    62,    63,    63,    63,    63,    63,    31,    26,
     0,     0,    54,    17,     6,    13,     0,    55,    59,    58,
    57,    56,    34,    28,    27,     0,    53,    51,    71,     9,
    67,     0,    35,    38,    34,    63,    63,    63,    63,    63,
    52,    73,    67,     0,    32,     0,     0,     0,    10,     6,
     0,    42,    63,    67,    21,    45,    43,    33,    41,    39,
    29,     0,    67,     0,    36,     0,     6,    22,    44,     0,
    40,    30,    18,    37,    67,    19,     0,     0,     0
};

static const short yydefgoto[] = {   147,
     2,    20,    63,     7,    30,   113,    24,    71,    22,    42,
    99,   145,    72,   133,    43,    67,    80,   105,   136,    93,
   121,   102,   141,   103,   116,   135,   130,   128,   134,    81,
    82,    98,    83,   104,    88,    44,    29,    38,    47,    33,
    56,    50,    48,    11,    17,    35,    15
};

static const short yypact[] = {    29,
-32768,    48,    18,-32768,-32768,-32768,-32768,    65,-32768,-32768,
    20,    21,-32768,     6,    42,-32768,    36,-32768,-32768,-32768,
     6,    48,    18,    43,-32768,-32768,-32768,    95,    47,    60,
    49,    58,    62,-32768,    63,    66,    95,    88,-32768,    95,
-32768,    83,    66,    67,-32768,    95,    85,    95,    62,    95,
    84,-32768,     6,    92,-32768,    92,    99,    62,    66,-32768,
-32768,-32768,-32768,-32768,    92,-32768,    39,-32768,     6,    89,
    48,    43,-32768,   -11,    -9,    -6,    -4,     9,-32768,-32768,
    87,    27,    86,-32768,    84,-32768,    93,-32768,-32768,-32768,
-32768,-32768,    35,-32768,-32768,    90,-32768,-32768,    60,-32768,
    66,    91,-32768,-32768,    35,    92,    92,    92,    92,    92,
    94,    88,    48,    96,-32768,    90,    97,   101,-32768,    84,
    82,    98,    92,    66,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   103,    66,   104,   102,    82,    84,-32768,-32768,    35,
-32768,-32768,-32768,-32768,    66,-32768,   115,   118,-32768
};

static const short yypgoto[] = {-32768,
-32768,   -17,   -82,   -20,-32768,-32768,-32768,-32768,-32768,   -42,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,    14,-32768,   -18,-32768,-32768,-32768,    -5,-32768,-32768,
    37,-32768,    16,    81,   -47,    -2,    64,    31,    22,    34,
   -13,-32768,-32768,   112,-32768,     2,   100
};


#define	YYLAST		144


static const short yytable[] = {     8,
    52,    26,   100,    25,    12,    65,    66,    65,    68,    18,
    65,    19,    65,   -46,    34,   -49,    70,    73,   -48,     8,
   -47,     9,    10,    45,    12,    65,    34,    89,    90,    91,
    92,     1,    34,   -50,    60,    64,    61,   125,    31,    10,
    32,    16,    74,    75,    76,    77,    78,   -16,    95,   -83,
    86,    84,    21,    96,   143,    54,     3,    28,   114,    89,
    90,    91,    92,    79,    23,     4,     5,     6,     8,    36,
    31,    10,    32,    49,    37,   131,    13,   -85,    13,    58,
    14,   132,    53,     4,     5,     6,    39,    54,    40,   -24,
   138,    41,   119,   106,   107,   108,   109,   110,    31,    10,
    32,    46,   146,   126,   127,    62,    51,    59,    65,    69,
     8,    94,    85,    97,   148,   101,   115,   149,   117,   120,
    96,   144,   123,   124,    55,   129,   137,   139,   140,   112,
   142,   122,   111,   118,    27,    87,     0,     0,     0,     0,
     0,     0,     0,    57
};

static const short yycheck[] = {     2,
    43,    22,    85,    21,     3,    17,    54,    17,    56,     4,
    17,     6,    17,    25,    28,    25,    59,    65,    25,    22,
    25,     4,     5,    37,    23,    17,    40,    75,    76,    77,
    78,     3,    46,    25,    48,    53,    50,   120,     4,     5,
     6,    22,     4,     5,     6,     7,     8,     0,    22,    29,
    71,    69,    11,    27,   137,    21,     9,    15,   101,   107,
   108,   109,   110,    25,    29,    18,    19,    20,    71,    23,
     4,     5,     6,    40,    15,   123,    12,    29,    12,    46,
    16,   124,    16,    18,    19,    20,    29,    21,    27,    24,
   133,    29,   113,     4,     5,     6,     7,     8,     4,     5,
     6,    14,   145,    22,    23,    22,    24,    23,    17,    11,
   113,    25,    24,    28,     0,    23,    26,     0,   105,    24,
    27,   140,    26,    23,    44,    28,    24,    24,    27,    99,
   136,   116,    96,   112,    23,    72,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    44
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 155 "parsersynjava.y"
{
		cout << "CORP_DECLARATIF_OPT" << endl;
		nspMisc = new NsPaquetage(pileCS.top(),"_Inconnue",IDENTIFIANT_PAQUETAGE);
		pileCS.top()->ajouterNS(nspMisc);
		javaRacine = pileCS.top();
		//yydebug = 1;
		;
    break;}
case 3:
#line 163 "parsersynjava.y"
{
		AfficheurArbreSyntaxiqueJava vns;
		cout << "JAVAFILE -> FIN" << endl;
		cout << "pileCS=" << pileCS.size() << endl;
		while(pileCS.size() > 1) pileCS.pop();


		NoeudSyntaxique *ns = NULL;
		std::vector<NoeudSyntaxique *> vctNsc;
		nspMisc->getVctNs(vctNsc);
		std::vector<NoeudSyntaxique *>::iterator itc = vctNsc.begin();
		while(itc != vctNsc.end()) {
			NsClasse *nsc = ((NsClasse *)*itc);
			cout << "Non declare : " << nsc->nomCode << endl;
			std::vector<string>::iterator it=nsc->currentImport.begin();
			while((it != nsc->currentImport.end()) && (ns == NULL)) {
				ns = trouverNoeudSyntaxique((string)*it,nsc->nomCode);
				if(ns != NULL) {
					cout << "cool" << endl;
					}
				else
					{
					++it;
					}
				}
			if( ns != NULL) {
				nspMisc->supprimerNS(nsc);
				pileCS.top()->remplacerNS(nsc,ns);
				}
			++itc;
			}


		
		pileCS.top()->accepterVNS(&vns);
		;
    break;}
case 4:
#line 202 "parsersynjava.y"
{
		yyvsp[0].nsc->declare = true;
		yyval.nsc = yyvsp[0].nsc;
		;
    break;}
case 5:
#line 206 "parsersynjava.y"
{
		NsClasse *nsc;
		nsc = new NsClasse(pileCS.top(),string(yyvsp[0].identifiant.text,yyvsp[0].identifiant.taille),IDENTIFIANT_CLASS);	
		nsc->declare = true;
		yyval.nsc = nsc;
		;
    break;}
case 8:
#line 219 "parsersynjava.y"
{
		// Ce placer dans le contexte de la nouvelle classe.
		pileCS.top()->ajouterNS(yyvsp[0].nsc);
		pileCS.push(yyvsp[0].nsc);
		;
    break;}
case 9:
#line 225 "parsersynjava.y"
{
		pileCS.pop();
		;
    break;}
case 11:
#line 230 "parsersynjava.y"
{
		// Ce placer dans le contexte de la nouvelle classe.
		pileCS.top()->ajouterNS(yyvsp[0].nsc);
		pileCS.push(yyvsp[0].nsc);
		;
    break;}
case 12:
#line 236 "parsersynjava.y"
{
		pileCS.pop();
		;
    break;}
case 14:
#line 241 "parsersynjava.y"
{
		// Ce placer dans ce contexte pour tous les ajouts.
		pileCS.pop();
		pileCS.push(yyvsp[-1].nsp);
		
		int id=0;
		string s,d;
		s = yyvsp[-1].nsp->getNomComplet();
		d = "";
		while(id < s.size()) {
			if(s[id] == ':') {
				d += '.';
				id++;
				id++;
				}
			else {
				d += s[id];	
				id++;
				}
			}
		pileImport.top().ajouterImport(d);
		;
    break;}
case 17:
#line 268 "parsersynjava.y"
{
		// Ce placer dans le contexte de la nouvelle classe.
		pileCS.top()->ajouterNS(yyvsp[0].nsc);
		pileCS.push(yyvsp[0].nsc);
		
		;
    break;}
case 18:
#line 275 "parsersynjava.y"
{
		pileCS.pop();
		;
    break;}
case 20:
#line 280 "parsersynjava.y"
{
		// Ce placer dans le contexte de la nouvelle classe.
		pileCS.top()->ajouterNS(yyvsp[0].nsc);
		pileCS.push(yyvsp[0].nsc);
		;
    break;}
case 21:
#line 286 "parsersynjava.y"
{
		pileCS.pop();
		;
    break;}
case 25:
#line 295 "parsersynjava.y"
{
		NsClasse *nsc=(NsClasse *)pileCS.top();
		nsc->setVisibilite(yyvsp[-1].val);
		pileCS.push(new CsType(pileCS.top(),*yyvsp[0].type));	
		;
    break;}
case 26:
#line 301 "parsersynjava.y"
{
		pileCS.pop();
		;
    break;}
case 28:
#line 308 "parsersynjava.y"
{
		pileCS.push(yyvsp[-1].nsm);
		pileCS.push(new ContexteSemantique(pileCS.top(),string("ListParametre"),-1));
		;
    break;}
case 29:
#line 313 "parsersynjava.y"
{
		ContexteSemantique *cs;
		cs = pileCS.top();
		pileCS.pop();
		((NsMethode *)pileCS.top())->ajouterParametre(cs);
		delete cs;
		;
    break;}
case 30:
#line 321 "parsersynjava.y"
{
		pileCS.top()->getCsPere()->ajouterNS(pileCS.top());
		pileCS.pop();
		;
    break;}
case 31:
#line 326 "parsersynjava.y"
{
		// Declaration d'un constructeur.
		NsMethode *nsm;
		CsType *cst = (CsType *)pileCS.top();
		nsm = new NsMethode(pileCS.top()->getCsPere(),cst->getNomType(),IDENTIFIANT_METHODE);
		pileCS.push(nsm);
		pileCS.push(new ContexteSemantique(pileCS.top(),string("ListParametre"),-1));	
		;
    break;}
case 32:
#line 335 "parsersynjava.y"
{
		ContexteSemantique *cs;
		cs = pileCS.top();
		pileCS.pop();
		((NsMethode *)pileCS.top())->ajouterParametre(cs);
		delete cs;
		;
    break;}
case 33:
#line 343 "parsersynjava.y"
{
		// Struct pile : NsClasse,CsType,NsMethode
		// il faut appeller directement ajouterNS sur NsClasse pour eviter d'ajouter un type
		// de retour au constructeur.
		pileCS.top()->getCsPere()->getCsPere()->ajouterNS(pileCS.top());
		pileCS.pop();
		;
    break;}
case 38:
#line 365 "parsersynjava.y"
{
		pileCS.push(new CsType(pileCS.top(),*yyvsp[0].type));
		;
    break;}
case 39:
#line 369 "parsersynjava.y"
{
		pileCS.pop();
		;
    break;}
case 41:
#line 377 "parsersynjava.y"
{
		javaIgnorerInitParam();
		;
    break;}
case 43:
#line 385 "parsersynjava.y"
{
		javaIgnorerBrace();
		;
    break;}
case 45:
#line 390 "parsersynjava.y"
{
		NsMethode *nsm = (NsMethode *)pileCS.top();
		nsm->setAbstract(true);
		;
    break;}
case 46:
#line 398 "parsersynjava.y"
{
		yyval.nsm = new NsMethode(pileCS.top(),string(yyvsp[0].identifiant.text,yyvsp[0].identifiant.taille),IDENTIFIANT_METHODE);
		;
    break;}
case 47:
#line 402 "parsersynjava.y"
{
		yyval.nsm = new NsMethode(pileCS.top(),yyvsp[0].nsm->getNom(),IDENTIFIANT_METHODE);
		;
    break;}
case 48:
#line 406 "parsersynjava.y"
{
		yyval.nsm = new NsMethode(pileCS.top(),yyvsp[0].nsc->getNom(),IDENTIFIANT_METHODE);
		;
    break;}
case 49:
#line 410 "parsersynjava.y"
{
		yyval.nsm = new NsMethode(pileCS.top(),yyvsp[0].nsp->getNom(),IDENTIFIANT_METHODE);
		;
    break;}
case 50:
#line 414 "parsersynjava.y"
{
		yyval.nsm = new NsMethode(pileCS.top(),yyvsp[0].nsa->getNom(),IDENTIFIANT_METHODE);
		;
    break;}
case 53:
#line 429 "parsersynjava.y"
{javaIgnorerInitVar();;
    break;}
case 55:
#line 438 "parsersynjava.y"
{
		/* On ajoute cette identifiant  la liste */
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),string(yyvsp[-1].identifiant.text,yyvsp[-1].identifiant.taille),IDENTIFIANT_ATTRIBUT));
		;
    break;}
case 56:
#line 443 "parsersynjava.y"
{
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),yyvsp[-1].nsa->getNom(),IDENTIFIANT_ATTRIBUT));
		;
    break;}
case 57:
#line 447 "parsersynjava.y"
{
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),yyvsp[-1].nsm->getNom(),IDENTIFIANT_ATTRIBUT));
		;
    break;}
case 58:
#line 451 "parsersynjava.y"
{
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),yyvsp[-1].nsc->getNom(),IDENTIFIANT_ATTRIBUT));
		;
    break;}
case 59:
#line 455 "parsersynjava.y"
{
		pileCS.top()->ajouterNS(new NsAttribut(pileCS.top(),yyvsp[-1].nsp->getNom(),IDENTIFIANT_ATTRIBUT));
		;
    break;}
case 60:
#line 461 "parsersynjava.y"
{
		yyval.type = new Type(string(yyvsp[-1].identifiant.text,yyvsp[-1].identifiant.taille));
		;
    break;}
case 61:
#line 465 "parsersynjava.y"
{
		yyval.type = new Type(yyvsp[-1].nsc);
		;
    break;}
case 64:
#line 475 "parsersynjava.y"
{yyval.val = DF_PUBLIC;;
    break;}
case 65:
#line 476 "parsersynjava.y"
{yyval.val = DF_PROTECTED;;
    break;}
case 66:
#line 477 "parsersynjava.y"
{yyval.val = DF_PRIVATE;;
    break;}
case 67:
#line 478 "parsersynjava.y"
{yyval.val = DF_PRIVATE;;
    break;}
case 70:
#line 487 "parsersynjava.y"
{
		NsClasse *nsc;
		nsc = (NsClasse *)pileCS.top();
		nsc->ajouterClasseMere(yyvsp[0].nsc,DF_PUBLIC);	
		;
    break;}
case 74:
#line 500 "parsersynjava.y"
{
		NsClasse *nsc;
		nsc = (NsClasse *)pileCS.top();
		nsc->ajouterClasseMere(yyvsp[0].nsc,DF_PUBLIC);	
		;
    break;}
case 76:
#line 509 "parsersynjava.y"
{
		// Identifiant de classe.
		yyval.nsc = yyvsp[0].nsc;
		;
    break;}
case 77:
#line 514 "parsersynjava.y"
{
		NsClasse *nsc = new NsClasse(nspMisc,string(yyvsp[0].identifiant.text,yyvsp[0].identifiant.taille),IDENTIFIANT_CLASS);
		nspMisc->ajouterNS(nsc);
		pileImport.top().getCurrentImport(nsc->currentImport);
		yyval.nsc = nsc;
		;
    break;}
case 78:
#line 521 "parsersynjava.y"
{
		// Changer de contexte.
		pileCS.push(yyvsp[-1].nsp);
		;
    break;}
case 79:
#line 526 "parsersynjava.y"
{
		// Remonter NOM_LONG_CLASSE_MERE.
		if(yyvsp[0].nsc->declare == false) {yyvsp[0].nsc->nomCode = pileCS.top()->getNom() + string(".") + yyvsp[0].nsc->nomCode;}
		pileCS.pop();
		yyval.nsc = yyvsp[0].nsc;
		;
    break;}
case 80:
#line 533 "parsersynjava.y"
{
		// Changer de contexte.
		pileCS.push(yyvsp[-1].nsc);
		;
    break;}
case 81:
#line 538 "parsersynjava.y"
{
		// Remonter NOM_LONG_CLASSE_MERE.
		if(yyvsp[0].nsc->declare == false) {yyvsp[0].nsc->nomCode = pileCS.top()->getNom() + string(".") + yyvsp[0].nsc->nomCode;}
		pileCS.pop();
		yyval.nsc = yyvsp[0].nsc;
		;
    break;}
case 82:
#line 548 "parsersynjava.y"
{
		yyval.nsp=yyvsp[0].nsp;
		;
    break;}
case 83:
#line 552 "parsersynjava.y"
{
		pileCS.push(yyvsp[0].nsp);	
		;
    break;}
case 84:
#line 556 "parsersynjava.y"
{
		pileCS.pop();
		yyval.nsp = yyvsp[0].nsp;
		;
    break;}
case 85:
#line 564 "parsersynjava.y"
{
		NsPaquetage *nsp;
		nsp = new NsPaquetage(pileCS.top(),string(yyvsp[0].identifiant.text,yyvsp[0].identifiant.taille),IDENTIFIANT_PAQUETAGE);
		pileCS.top()->ajouterNS(nsp);
		yyval.nsp = nsp;
		;
    break;}
case 86:
#line 571 "parsersynjava.y"
{
		yyval.nsp = yyvsp[0].nsp;
		;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 579 "parsersynjava.y"




