#ifndef VNSEXPORTNOYAU_H
#define VNSEXPORTNOYAU_H

class ContexteSemantique;
class Noyau;
class DiagrammeStatique;
class Paquetage;
class Classe;

/**
 *Cette implementation du visiteur VisiteurNoeudSyntaxique  pour but d'effectuer
 *une traduction de l'arbre syntaxique du parser vers l'architecture du noyau.
 *@changelog lun fv 04 16:17:52 CET 2002 syj <syj@ifrance.com>
 *@author syj
 */

class VnsExportNoyau : public VisiteurNoeudSyntaxique {
		Noyau *n;
		DiagrammeStatique *dg;
		ContexteSemantique *cs;
		Paquetage *paq;
		Classe *cls;
				
        public:
        	VnsExportNoyau(Noyau *noyau,DiagrammeStatique *diagrammeStatique,ContexteSemantique *contextesemantique);
        	
                virtual void traiterContexteSemantique(ContexteSemantique *cs);

                virtual void traiterNsClasse(NsClasse *nsc);

                virtual void traiterNsPaquetage(NsPaquetage *nsc);

                virtual void traiterNsMethode(NsMethode *nsm);

                virtual void traiterNsAttribut(NsAttribut *nsa);
        };
#endif